{**********************************************************}
{                                                          }
{   TMaskEditHV 3.0                                        }
{   Autor: Hamden Vogel                                    }
{   E-mail: hamdenvogel@gmail.com                          }
{   http://www.hvogel.com.br                               }
{                                                          }
{   Freeware. ltima atualizao: 20/12/2010               }
{                                                          }
{**********************************************************}
{                                                          }
{**********************************************************}
{                                                          }
{ Componente descendente do TMaskedit com vrios           }
{ tipos de formatao e validao, dependendo da           }
{ mscara escolhida.                                       }
{  possvel tambm estender os tipos de formatao.       }
{ Tambm suporta outras funcionalidades, como alterao da }
{ da cor quando est com o foco e processamento automtico }
{ quando pressionada a tecla <Enter>.                      }
{                                                          }
{ Formatao e Validao de:                               }
{ * Data                                                   }
{ * Data/Hora                                              }
{ * Hora                                                   }
{ * CPF                                                    }
{ * CNPJ                                                   }
{ * CEP                                                    }
{ * Email                                                  }
{ * Profisso                                              }
{ * Escolaridade                                           }
{ * Moeda                                                  }
{ * Telefone                                               }
{ * Usurio (Nome)                                         }
{ * Endereo                                               }
{ * Estado                                                 }
{ * Cidade                                                 }
{ * Complemento                                            }
{ * Setor                                                  }
{ * 5 Campos Adicionais Customizveis (CheckUser **)       }
{                                                          }
{ Pode-se customizar:                                      }
{ 1: Mensagens de Erro (retornadas ao Usurio):            }
{   1.1: Formatar o Contedo da Mensagem;                  }
{                                                          }
{     1.1.1: Formatar o Nome do Componente associado a Mensagem; }
{                                                          }
{   1.2: Formatar o nome do Ttulo da Mensagem.            }
{                                                          }
{ 2: Opes de Validao:                                  }
{                                                          }
{   2.1: Se realiza a Validao ou no, de acordo com o preenchimento }
{   do campo. Se sim, o usurio somente deixar o campo se ele possuir}
{   a informao correta de acordo com o tipo de dado escolhido.      }
{                                                                     }
{     2.1.1: No caso de validao falsa, e se configurado para        }
{     criticar sua validao:                                         }
{                                                                     }
{       2.1.1.1: O componente exibir uma mensagem personalizada criticando sua validao incorreta; }

{     2.1.2: No caso de validao falsa, e se no configurado para    }
{     criticar sua validao:                                         }

{       2.1.2.1: O componente no exibir mensagem, mas prender o foco nele (crtica silenciosa).   }

{   2.2: Verificar se o campo est diferente de vazio:                }
{                                                                     }
{     2.2.1: Se realiza a verificao do campo preenchido ou no.     }
{     Se sim, o usurio somente deixar o campo se o mesmo estiver    }
{     preenchido. Note-se que a validao do contedo ser feita      }
{     de acordo com as configuraes definidas no item 1.             }
{                                                                     }
{      2.2.2: No caso de campo no preenchido, e se configurado para  }
{      criticar seu preenchimento (de acordo com as configuraes definidas }
{      no item 2.2.1):
{                                                                     }
{        2.2.2.1: O componente exibir uma mensagem personalizada criticando seu preenchimento; }

{      2.2.3: No caso de campo no preenchido, e se configurado para no }
{      criticar seu preenchimento (de acordo com as configuraes definidas }
{      no item 2.2.1):

{        2.2.3.1: O componente no exibir mensagem, mas prender o foco nele (crtica silenciosa). }
{
{ Portanto, as validaes so para assegurar que os campos esto      }
{ sendo preenchidos corretamente, tanto para o contedo em si, tanto  }
{ para preenchimento completo da informao.                          }
{  possvel customizar tipos de formatos,                  }
{ tipos de mensagens de erro,                               }
{ nome do campo, validao dos formatos,                    }
{ exibio (sim ou no) de mensagens ao usurio notificando }
{ campo vazio/invlido.                                     }


unit MaskEditHV;

interface

uses
   Mask, SysUtils, Math, Classes, Windows, Forms, Messages, StdCtrls,
   MaskUtils, DateUtils, Dialogs, Graphics, DBClient, MidasLib, ComCtrls;

const
  cVersion = '4.0';

type
   TMaskEditHV = class(TMaskEdit)
   private
      FInvalidDateMSG: string;
      fInvalidTimeMSG: string;
      fInvalidDateTimeMSG: string;
      fInvalidCPFMSG: string;
      fInvalidCNPJMSG: string;
      fInvalidCEPMSG: String;
      fInvalidTelMSG: String;
      fInValidUserNameMSG: string;
      fInvalidAddressMSG: string;
      fInvalidSectorMSG: string;
      fInvalidCityMSG: string;
      fInvalidStateMSG: string;
      fInvalidEmailMSG: string;
      fInvalidProfissaoMSG: string;
      fInvalidEscolaridadeMSG: string;
      fInvalidComplementoMSG: string;
      fInvalidMoneyMSG: string;
      fInvalidUser01MSG: string;
      fInvalidUser02MSG: string;
      fInvalidUser03MSG: string;
      fInvalidUser04MSG: string;
      fInvalidUser05MSG: string;
      fCheckDate: Boolean;
      fShowF1Date: Boolean;
      fCheckDateTime: Boolean;
      fCheckTime: Boolean;
      fCheckCPF: Boolean;
      fCheckCNPJ: Boolean;
      fCheckCEP: Boolean;
      fCheckTel: Boolean;
      fTelDDDFormat: Boolean;
      fCheckUserName: Boolean;
      fCheckAddress: Boolean;
      fCheckSector: Boolean;
      fCheckCity: Boolean;
      fCheckState: Boolean;
      combo: TComboBox;
      MonthCalendar: TMonthCalendar;
      fShowListState: Boolean;
      fShowListCity: Boolean;
      fShowListProfissao: Boolean;
      fShowListEscolaridade: Boolean;
      fCheckEmail: Boolean;
      fCheckProfissao: Boolean;
      fCheckEscolaridade: Boolean;
      FEmailMessage: string;
      fCheckComplemento: Boolean;
      fCheckMoney: Boolean;
      fCheckUser01: Boolean;
      fCheckUser02: Boolean;
      fCheckUser03: Boolean;
      fCheckUser04: Boolean;
      fCheckUser05: Boolean;
      fShowInvalidDateMSG: Boolean;
      fShowInvalidDateTimeMSG: Boolean;
      fShowInvalidTimeMSG: Boolean;
      fShowInvalidCPFMSG: Boolean;
      fShowInvalidCNPJMSG: Boolean;
      fShowInvalidCEPMSG: Boolean;
      fShowInvalidTelMSG: Boolean;
      fShowInvalidUserNameMSG: Boolean;
      fShowInvalidAddressMSG: Boolean;
      fShowInvalidSectorMSG: Boolean;
      fShowInvalidCityMSG: Boolean;
      fShowInvalidStateMSG: Boolean;
      fShowInvalidEmailMSG: Boolean;
      fShowInvalidProfissaoMSG: Boolean;
      fShowInvalidEscolaridadeMSG: Boolean;
      fShowInvalidComplementoMSG: Boolean;
      fShowInvalidMoneyMSG: Boolean;
      fShowInvalidUser01MSG: Boolean;
      fShowInvalidUser02MSG: Boolean;
      fShowInvalidUser03MSG: Boolean;
      fShowInvalidUser04MSG: Boolean;
      fShowInvalidUser05MSG: Boolean;
      fTitleErrorMSG: String;
      fTitleWarningMSG: String;
      fTitleOKMSG: String;
      fEstado: string;
      fShowCurrencyString: Boolean;
      fEstadoCEPAutoDetect: Boolean;
      fCheckEmptyDate: Boolean;
      fCheckEmptyDateTime: Boolean;
      fCheckEmptyTime: Boolean;
      fCheckEmptyCPF: Boolean;
      fCheckEmptyCNPJ: Boolean;
      fCheckEmptyCEP: Boolean;
      fCheckEmptyTel: Boolean;
      fCheckEmptyUserName: Boolean;
      fCheckEmptyAddress: Boolean;
      fCheckEmptySector: Boolean;
      fCheckEmptyCity: Boolean;
      fCheckEmptyState: Boolean;
      fCheckEmptyEmail: Boolean;
      fCheckEmptyProfissao: Boolean;
      fCheckEmptyEscolaridade: Boolean;
      fCheckEmptyComplemento: Boolean;
      fCheckEmptyMoney: Boolean;
      fCheckEmptyUser01: Boolean;
      fCheckEmptyUser02: Boolean;
      fCheckEmptyUser03: Boolean;
      fCheckEmptyUser04: Boolean;
      fCheckEmptyUser05: Boolean;
      fDateName: String;
      fDateTimeName: String;
      fTimeName: String;
      fCPFName: String;
      fCNPJName: string;
      fCEPName: string;
      fTELName: String;
      fUserName: String;
      fAddressName: string;
      fSectorName: string;
      fCityName: string;
      fStateName: string;
      fEmailName: string;
      fProfissaoName: string;
      fEscolaridadeName: string;
      fComplementoName: string;
      fMoneyName: string;
      fUser01Name: string;
      fUser02Name: string;
      fUser03Name: string;
      fUser04Name: string;
      fUser05Name: string;
      fCannotContainEmptyCaracter: string;
      bSilentError: Boolean;
      fVersion: string;
      fCorAtiva: TColor;
      fCorNaoAtiva: TColor;
      procedure SetInvalidDateMSG(const Value: string);
      procedure SetInvalidDateTimeMSG(const Value: string);
      procedure SetInvalidTimeMSG(const Value: string);
      procedure SetInvalidCPFMSG(const Value: string);
      procedure SetInvalidCNPJMSG(const Value: string);
      procedure SetInvalidCEPMSG(const Value: string);
      procedure SetInvalidTelMSG(const Value: string);
      procedure SetInvalidUserNameMSG(const Value: string);
      procedure SetInvalidAddressMSG(const Value: string);
      procedure SetInvalidSectorMSG(const Value: string);
      procedure SetInvalidCityMSG(const Value: string);
      procedure SetInvalidStateMSG(const Value: string);
      procedure SetInvalidEmailMSG(const Value: string);
      procedure SetInvalidProfissaoMSG(const Value: string);
      procedure SetInvalidEscolaridadeMSG(const Value: string);
      procedure SetInvalidComplementoMSG(const Value: string);
      procedure SetInvalidMoneyMSG(const Value: string);
      procedure SetInvalidUser01MSG(const Value: string);
      procedure SetInvalidUser02MSG(const Value: string);
      procedure SetInvalidUser03MSG(const Value: string);
      procedure SetInvalidUser04MSG(const Value: string);
      procedure SetInvalidUser05MSG(const Value: string);
      procedure SetShowInvalidDateMSG(const Value: Boolean);
      procedure SetShowInvalidDateTimeMSG(const Value: Boolean);
      procedure SetShowInvalidTimeMSG(const Value: Boolean);
      procedure SetShowInvalidCPFMSG(const Value: Boolean);
      procedure SetShowInvalidCNPJMSG(const Value: Boolean);
      procedure SetShowInvalidCEPMSG(const Value: Boolean);
      procedure SetShowInvalidTelMSG(const Value: Boolean);
      procedure SetShowInvalidUserNameMSG(const Value: Boolean);
      procedure SetShowInvalidAddressMSG(const Value: Boolean);
      procedure SetShowInvalidSectorMSG(const Value: Boolean);
      procedure SetShowInvalidCityMSG(const Value: Boolean);
      procedure SetShowInvalidStateMSG(const Value: Boolean);
      procedure SetShowInvalidEmailMSG(const Value: Boolean);
      procedure SetShowInvalidProfissaoMSG(const Value: Boolean);
      procedure SetShowInvalidEscolaridadeMSG(const Value: Boolean);
      procedure SetShowInvalidComplementoMSG(const Value: Boolean);
      procedure SetShowInvalidMoneyMSG(const Value: Boolean);
      procedure SetShowInvalidUser01MSG(const Value: Boolean);
      procedure SetShowInvalidUser02MSG(const Value: Boolean);
      procedure SetShowInvalidUser03MSG(const Value: Boolean);
      procedure SetShowInvalidUser04MSG(const Value: Boolean);
      procedure SetShowInvalidUser05MSG(const Value: Boolean);
      procedure SetTitleErrorMSG(const Value: String);
      procedure SetTitleWarningMSG(const Value: String);
      procedure SetTitleOKMSG(const Value: String);
      procedure GoTab;
      procedure GoEnter;
      procedure SetCheckDate(const Valor: Boolean);
      procedure SetShowF1Date(const Value: Boolean);
      procedure SetCheckDateTime(const Valor: Boolean);
      procedure SetCheckTime(const Value: Boolean);
      procedure SetCheckCPF(const Value: Boolean);
      procedure SetCheckCNPJ(const Value: Boolean);
      procedure SetCheckCEP(const Value: Boolean);
      procedure SetCheckTel(const Value: Boolean);
      procedure SetTelDDDFormat(const Value: Boolean);
      procedure SetCheckUserName(const Value: Boolean);
      procedure SetCheckAddress(const Value: Boolean);
      procedure SetCheckSector(const Value: Boolean);
      procedure SetCheckCity(const Value: Boolean);
      procedure SetCheckState(const Value: Boolean);
      procedure SetCheckEmail(const Value: Boolean);
      procedure SetCheckProfissao(const Value: Boolean);
      procedure SetCheckEscolaridade(const Value: Boolean);
      procedure SetCheckComplemento(const Value: Boolean);
      procedure SetCheckMoney(const Value: Boolean);
      procedure SetCheckUser01(const Value: Boolean);
      procedure SetCheckUser02(const Value: Boolean);
      procedure SetCheckUser03(const Value: Boolean);
      procedure SetCheckUser04(const Value: Boolean);
      procedure SetCheckUser05(const Value: Boolean);

      procedure GetList;
      procedure GetMonthCalendar;
      procedure MonthCalendarDblClick(Sender: TObject);
      procedure MonthCalendarKeyPress(Sender: TObject; var Key: Char);

      //procedure GetListCities;
      procedure MyChange(Sender: TObject);
      procedure MyKeyPress(Sender: TObject; var Key: Char);
      procedure SetListState(const Value: Boolean);
      procedure SetListCity(const Value: Boolean);
      procedure SetListProfissao(const Value: Boolean);
      procedure SetListEscolaridade(const Value: Boolean);

      procedure SetEstado(const Value: string);
      procedure SetShowCurrencyString(const Value: Boolean);
      procedure SetEstadoCEPAutoDetect(const Value: Boolean);
      procedure SetEmptyCheckDate(const Value: Boolean);
      procedure SetEmptyCheckDateTime(const Value: Boolean);
      procedure SetEmptyCheckTime(const Value: Boolean);
      procedure SetEmptyCheckCPF(const Value: Boolean);
      procedure SetEmptyCheckCNPJ(const Value: Boolean); 
      procedure SetEmptyCheckCEP(const Value: Boolean);
      procedure SetEmptyCheckTel(const Value: Boolean);
      procedure SetEmptyCheckUserName(const Value: Boolean);
      procedure SetEmptyCheckAddress(const Value: Boolean);
      procedure SetEmptyCheckSector(const Value: Boolean);
      procedure SetEmptyCheckCity(const Value: Boolean);
      procedure SetEmptyCheckState(const Value: Boolean);
      procedure SetEmptyCheckEmail(const Value: Boolean);
      procedure SetEmptyCheckProfissao(const Value: Boolean);
      procedure SetEmptyCheckEscolaridade(const Value: Boolean);
      procedure SetEmptyCheckComplemento(const Value: Boolean);
      procedure SetEmptyCheckMoney(const Value: Boolean);
      procedure SetEmptyCheckUser01(const Value: Boolean);
      procedure SetEmptyCheckUser02(const Value: Boolean);
      procedure SetEmptyCheckUser03(const Value: Boolean);
      procedure SetEmptyCheckUser04(const Value: Boolean);
      procedure SetEmptyCheckUser05(const Value: Boolean);
      procedure SetDateName(const Value: String);
      procedure SetDateTimeName(const Value: String);
      procedure SetTimeName(const Value: String);
      procedure SetCPFName(const Value: String);
      procedure SetCNPJName(const Value: String);
      procedure SetCEPName(const Value: String);
      procedure SetTELName(const Value: String);
      procedure SetUserName(const Value: String);
      procedure SetAddressName(const Value: String);
      procedure SetSectorName(const Value: String);
      procedure SetCityName(const Value: String);
      procedure SetStateName(const Value: String);
      procedure SetEmailName(const Value: String);
      procedure SetProfissaoName(const Value: String);
      procedure SetEscolaridadeName(const Value: String);
      procedure SetComplementoName(const Value: String);
      procedure SetMoneyName(const Value: string);
      procedure SetUser01Name(const Value: String);
      procedure SetUser02Name(const Value: String);
      procedure SetUser03Name(const Value: String);
      procedure SetUser04Name(const Value: String);
      procedure SetUser05Name(const Value: String);
      procedure SetVersion(const Value: String);
      procedure SetCannotContainEmptyCaracter(const Value: String);
      function HourExistsToo: Boolean;
      function WithoutAllSpaces(const S: String): String;
      //no utilizadas ainda:
      function AllDisabledCheckFunctions: Boolean;
      procedure RestoreDefaultCheckFunctions;
      function IsSomeCheckFunctionSelected: Boolean;
      function FilterChar(const T : string) : string;
      // ****************
      function EmptyHourExistsInDateTimeFormat: Boolean;

      function IsValidDate(const FStringDate: string): Boolean; overload;
      function IsValidTime(const FStringTime: string): Boolean; overload;
      function IsValidCPF(const FStringCPF: string): Boolean; overload;
      function IsValidCNPJ(const FStringCNPJ: string): Boolean; overload;
      //function IsValidTel(const fStringTel: string): Boolean; overload;
      procedure TrimMask;
      procedure UnTrimMask;
//    function TelFormat: Boolean;
    
   // procedure MyChange(Sender: TObject);

   protected
      procedure KeyDown(var Key: Word; Shift: TShiftState); override;
      procedure KeyPress(var Key: Char); override;
      procedure Click; override;
      procedure DoEnter; override;
      procedure DoExit; override;
   public
      constructor Create (AOwner: TComponent); override;

      //procedure Teste;
      function EmptyDate: Boolean;
      function EmptyDateTime: Boolean;
      function EmptyTime: Boolean;
      function EmptyCPF: Boolean;
      function EmptyCNPJ: Boolean;
      function EmptyCEP: Boolean;
      function EmptyTel: Boolean;
      function EmptyTel1: Boolean;
      function EmptyTel2: Boolean;
      function EmptyUserName: Boolean;
      function EmptyAddress: Boolean;
      function EmptyCity: Boolean;
      function EmptySector: Boolean;
      function EmptyState: Boolean;
      function EmptyEmail: Boolean;
      function EmptyProfissao: Boolean;
      function EmptyEscolaridade: Boolean;
      function EmptyComplemento: Boolean;
      function EmptyMoney: Boolean;
      function EmptyUser01: Boolean;
      function EmptyUser02: Boolean;
      function EmptyUser03: Boolean;
      function EmptyUser04: Boolean;
      function EmptyUser05: Boolean;
      function EmptyExists: Boolean;
      function DateFormat: Boolean;
      function TimeFormat: Boolean;
      function DateTimeFormat: Boolean;
      function CPFFormat: Boolean;
      function CNPJFormat: Boolean;
      function CEPFormat: Boolean;
      function TelFormat1: Boolean;
      function TelFormat2: Boolean;
      function IsValidDate: Boolean; overload;
      function IsValidTime: Boolean; overload;
      function IsValidDateAndTime: Boolean;
      function IsValidCPF: Boolean; overload;
      function IsValidCNPJ: Boolean; overload;
      function IsValidCEP: Boolean;
//      function IsValidTel: Boolean; overload;
      function IsValidEmail: Boolean;
      function CheckIfEmptyDate: Boolean;
      function CheckIfEmptyDateTime: Boolean;
      function CheckIfEmptyTime: Boolean;
      function IsSilentError: Boolean;
      function extractResFromPas(binresname: string; path: string): boolean;
      procedure LoadTempXML(const tempXML: string; const tempIndex: string);
      Procedure DelFile(vMasc:String);
      function GetCurrentState: string; //obter o estado (UF) informado

   published
      property DateName: String read fDateName write SetDateName;
      property DateTimeName: String read fDateTimeName write SetDateTimeName;
      property TimeName: String read fTimeName write SetTimeName;
      property CPFName: String read fCPFName write SetCPFName;
      property CNPJName: String read fCNPJName write SetCNPJName;
      property CEPName: String read fCEPName write SetCEPName;
      property TELName: String read fTELName write SetTELName;
      property UserName: String read fUserName write SetUserName;
      property AddressName: String read fAddressName write SetAddressName;
      property SectorName: String read fSectorName write SetSectorName;
      property CityName: String read fCityName write SetCityName;
      property StateName: String read fStateName write SetStateName;
      property EmailName: String read fEmailName write SetEmailName;
      property ProfissaoName: String read fProfissaoName write SetProfissaoName;
      property EscolaridadeName: String read fEscolaridadeName write SetEscolaridadeName;
      property ComplementoName: String read fComplementoName write SetComplementoName;
      property MoneyName: String read fMoneyName write SetMoneyName;
      property User01Name: String read fUser01Name write SetUser01Name;
      property User02Name: String read fUser02Name write SetUser02Name;
      property User03Name: String read fUser03Name write SetUser03Name;
      property User04Name: String read fUser04Name write SetUser04Name;
      property User05Name: String read fUser05Name write SetUser05Name;
      property InvalidDateMSG: string read FInvalidDateMSG write SetInvalidDateMSG;
      property InvalidDateTimeMSG: String read fInvalidDateTimeMSG write SetInvalidDateTimeMSG;
      property InvalidTimeMSG: string read fInvalidTimeMSG write SetInvalidTimeMSG;
      property InvalidCPFMSG: string read fInvalidCPFMSG write SetInvalidCPFMSG;
      property InvalidCNPJMSG: string read fInvalidCNPJMSG write SetInvalidCNPJMSG;
      property InvalidCEPMSG: string read fInvalidCEPMSG write SetInvalidCEPMSG;
      property InvalidTelMSG: String read fInvalidTelMSG write SetInvalidTelMSG;
      property InvalidUserNameMGS: String read fInValidUserNameMSG write SetInvalidUserNameMSG;
      property InvalidAddressMSG: String read fInvalidAddressMSG write SetInvalidAddressMSG;
      property InvalidSectorMSG: String read fInvalidSectorMSG write SetInvalidSectorMSG;
      property InvalidCityMSG: String read fInvalidCityMSG write SetInvalidCityMSG;
      property InvalidStateMSG: String read fInvalidStateMSG write SetInvalidStateMSG;
      property InvalidEmailMSG: String read fInvalidEmailMSG write SetInvalidEmailMSG;
      property InvalidProfissaoMSG: string read fInvalidProfissaoMSG write SetInvalidProfissaoMSG;
      property InvalidEscolaridadeMSG: string read fInvalidEscolaridadeMSG write SetInvalidEscolaridadeMSG;
      property InvalidComplementoMSG: String read fInvalidComplementoMSG write SetInvalidComplementoMSG;
      property InvalidMoneyMSG: String read fInvalidMoneyMSG write SetInvalidMoneyMSG;
      property InvalidUser01MSG: String read fInvalidUser01MSG write SetInvalidUser01MSG;
      property InvalidUser02MSG: String read fInvalidUser02MSG write SetInvalidUser02MSG;
      property InvalidUser03MSG: String read fInvalidUser03MSG write SetInvalidUser03MSG;
      property InvalidUser04MSG: String read fInvalidUser04MSG write SetInvalidUser04MSG;
      property InvalidUser05MSG: String read fInvalidUser05MSG write SetInvalidUser05MSG;
      property ShowInvalidDateMSG: Boolean read fShowInvalidDateMSG write SetShowInvalidDateMSG default True;
      property ShowInvalidDateTimeMSG: Boolean read fShowInvalidDateTimeMSG write SetShowInvalidDateTimeMSG default True;
      property ShowInvalidTimeMSG: Boolean read fShowInvalidTimeMSG write SetShowInvalidTimeMSG default True;
      property ShowInvalidCPFMSG: Boolean read fShowInvalidCPFMSG write SetShowInvalidCPFMSG default True;
      property ShowInvalidCNPJMSG: Boolean read fShowInvalidCNPJMSG write SetShowInvalidCNPJMSG default True;
      property ShowInvalidCEPMSG: Boolean read fShowInvalidCEPMSG write SetShowInvalidCEPMSG default True;
      property ShowInvalidTelMSG: Boolean read fShowInvalidTelMSG write SetShowInvalidTelMSG default True;
      property ShowInvalidUserNameMSG: Boolean read fShowInvalidUserNameMSG write SetShowInvalidUserNameMSG default True;
      property ShowInvalidAddressMSG: Boolean read fShowInvalidAddressMSG write SetShowInvalidAddressMSG default True;
      property ShowInvalidSectorMSG: Boolean read fShowInvalidSectorMSG write SetShowInvalidSectorMSG default True;
      property ShowInvalidCityMSG: Boolean read fShowInvalidCityMSG write SetShowInvalidCityMSG default True;
      property ShowInvalidStateMSG: Boolean read fShowInvalidStateMSG write SetShowInvalidStateMSG default True;
      property ShowInvalidEmailMSG: Boolean read fShowInvalidEmailMSG write SetShowInvalidEmailMSG default True;
      property ShowInvalidProfissaoMSG: Boolean read fShowInvalidProfissaoMSG write SetShowInvalidProfissaoMSG default true;
      property ShowInvalidEscolaridadeMSG: Boolean read fShowInvalidEscolaridadeMSG write SetShowInvalidEscolaridadeMSG default true;
      property ShowInvalidComplementoMSG: Boolean read fShowInvalidComplementoMSG write SetShowInvalidComplementoMSG default True;
      property ShowInvalidMoneyMSG: Boolean read fShowInvalidMoneyMSG write SetShowInvalidMoneyMSG default True;
      property ShowInvalidUser01MSG: Boolean read fShowInvalidUser01MSG write SetShowInvalidUser01MSG default True;
      property ShowInvalidUser02MSG: Boolean read fShowInvalidUser02MSG write SetShowInvalidUser02MSG default True;
      property ShowInvalidUser03MSG: Boolean read fShowInvalidUser03MSG write SetShowInvalidUser03MSG default True;
      property ShowInvalidUser04MSG: Boolean read fShowInvalidUser04MSG write SetShowInvalidUser04MSG default True;
      property ShowInvalidUser05MSG: Boolean read fShowInvalidUser05MSG write SetShowInvalidUser05MSG default True;
      property StringCannotContainEmptyCaracter: String read fCannotContainEmptyCaracter write SetCannotContainEmptyCaracter;
      property TitleErrorMSG: String read fTitleErrorMSG write SetTitleErrorMSG;
      property TitleWarningMSG: String read fTitleWarningMSG write SetTitleWarningMSG;
      property TitleOKMSG: String read fTitleOKMSG write SetTitleOKMSG;
      property Estado: string read fEstado write SetEstado; //Estado do CEP ...
      property ShowCurrencyString: Boolean read fShowCurrencyString write SetShowCurrencyString;
      property EstadoCEPAutoDetect: Boolean read fEstadoCEPAutoDetect write SetEstadoCEPAutoDetect;
      property CheckDate: Boolean read fCheckDate write SetCheckDate;
      property ShowF1Date: Boolean read fShowF1Date write SetShowF1Date;
      property CheckDateTime: Boolean read fCheckDateTime write SetCheckDateTime;
      property CheckTime: Boolean read fCheckTime write SetCheckTime;
      property CheckCPF: Boolean  read fCheckCPF  write SetCheckCPF;
      property CheckCNPJ: Boolean read fCheckCNPJ  write SetCheckCNPJ;
      property CheckCEP: Boolean  read fCheckCEP  write SetCheckCEP;
      property CheckTel: Boolean  read fCheckTel  write SetCheckTel;
      property ShowTelDDDFormat: Boolean read fTelDDDFormat write SetTelDDDFormat;
      property CheckUserName: Boolean  read fCheckUserName  write SetCheckUserName;
      property CheckAddress: Boolean  read fCheckAddress  write SetCheckAddress;
      property CheckSector: Boolean  read fCheckSector  write SetCheckSector;
      property CheckCity: Boolean  read fCheckCity  write SetCheckCity;
      property CheckState: Boolean  read fCheckState  write SetCheckState;
      property ShowListState: Boolean read fShowListState write SetListState;
      property ShowListCity: Boolean read fShowListCity write SetListCity;
      property ShowListProfissao: Boolean read fShowListProfissao write SetListProfissao;
      property ShowListEscolaridade: Boolean read fShowListEscolaridade write SetListEscolaridade;
      property CheckEmail: Boolean  read fCheckEmail  write SetCheckEmail;
      property CheckProfissao: Boolean read fCheckProfissao write SetCheckProfissao;
      property CheckEscolaridade: Boolean read fCheckEscolaridade write SetCheckEscolaridade; 
      property EmailMessage: string read FEmailMessage;
      property CheckComplemento: Boolean  read fCheckComplemento  write SetCheckComplemento;
      property CheckMoney: Boolean   read fCheckMoney   write SetCheckMoney;
      property CheckUser01: Boolean  read fCheckUser01  write SetCheckUser01;
      property CheckUser02: Boolean  read fCheckUser02  write SetCheckUser02;
      property CheckUser03: Boolean  read fCheckUser03  write SetCheckUser03;
      property CheckUser04: Boolean  read fCheckUser04  write SetCheckUser04;
      property CheckUser05: Boolean  read fCheckUser05  write SetCheckUser05;
      property CheckEmptyDate: Boolean      read fCheckEmptyDate      write SetEmptyCheckDate;
      property CheckEmptyDateTime: Boolean  read fCheckEmptyDateTime  write SetEmptyCheckDateTime;
      property CheckEmptyTime: Boolean      read fCheckEmptyTime      write SetEmptyCheckTime;
      property CheckEmptyCPF: Boolean       read fCheckEmptyCPF       write SetEmptyCheckCPF;
      property CheckEmptyCNPJ: Boolean      read fCheckEmptyCNPJ      write SetEmptyCheckCNPJ;
      property CheckEmptyCEP: Boolean       read fCheckEmptyCEP       write SetEmptyCheckCEP;
      property CheckEmptyTEL: Boolean       read fCheckEmptyTel       write SetEmptyCheckTel;
      property CheckEmptyUserName: Boolean  read fCheckEmptyUserName  write SetEmptyCheckUserName;
      property CheckEmptyAddress: Boolean   read fCheckEmptyAddress   write SetEmptyCheckAddress;
      property CheckEmptySector: Boolean    read fCheckEmptySector    write SetEmptyCheckSector;
      property CheckEmptyCity: Boolean      read fCheckEmptyCity      write SetEmptyCheckCity;
      property CheckEmptyState: Boolean     read fCheckEmptyState     write SetEmptyCheckState;
      property CheckEmptyEmail: Boolean     read fCheckEmptyEmail     write SetEmptyCheckEmail;
      property CheckEmptyProfissao: Boolean read fCheckEmptyProfissao write SetEmptyCheckProfissao;
      property CheckEmptyEscolaridade: Boolean read fCheckEmptyEscolaridade write SetEmptyCheckEscolaridade;
      property CheckEmptyComplemento: Boolean  read fCheckEmptyComplemento       write SetEmptyCheckComplemento;
      property CheckEmptyMoney: Boolean     read fCheckEmptyMoney     write SetEmptyCheckMoney; 
      property CheckEmptyUser01: Boolean    read fCheckEmptyUser01    write SetEmptyCheckUser01;
      property CheckEmptyUser02: Boolean    read fCheckEmptyUser02    write SetEmptyCheckUser02;
      property CheckEmptyUser03: Boolean    read fCheckEmptyUser03    write SetEmptyCheckUser03;
      property CheckEmptyUser04: Boolean    read fCheckEmptyUser04    write SetEmptyCheckUser04;
      property CheckEmptyUser05: Boolean    read fCheckEmptyUser05    write SetEmptyCheckUser05;
      property Version: string              read fVersion             write SetVersion;
      property CorAtiva: TColor             read fCorAtiva            write fCorAtiva;
      property CorNaoAtiva: TColor          read fCorNaoAtiva         write fCorNaoAtiva;
   end;

procedure Register;


implementation
{$R estados.res}
{$R cidades.res}
{$R escolaridade.res}
{$R profissao.res}

uses Controls, Types;


procedure TMaskEditHV.GoTab;
begin
 // funo desabilitada, pois no  necessria:
 // a funo de tabulao j  suportada pelo Windows,
 // e tambm pelos componentes do Delphi.
end;

procedure TMaskEditHV.GoEnter;
begin
  // simular a tecla <Tab> quando pressionada a tecla <Enter>.
  PostMessage(Handle, WM_KEYDOWN, VK_TAB, 0);
end;

procedure TMaskEditHV.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;

  if (key = vk_F1) and (fShowF1Date) and (fCheckDate) then
  begin
    GetMonthCalendar;
    Abort;
  end;

  if (Key in [13]) then
  begin
    if not(fShowListState) and not(fShowListCity) and not(fShowListProfissao) and not(fShowListEscolaridade) then
    begin
      GoEnter;
      Abort;
    end;
  end
  else if (key = (VK_DELETE)) and (fCheckMoney) then
  begin
    if fShowCurrencyString then Self.Text := FormatFloat('R$ #,0.00',0)
    else Self.Text := FormatFloat('#,0.00',0);

    Self.Click;
  end;
end;

procedure TMaskEditHV.KeyPress(var Key: Char);
var
  Texto, Texto2: string;
  i: byte;
begin
  inherited;
  if fCheckEmail then Self.CharCase := ecNormal;

  if ((fCheckState) and (fShowListState)) or
  ((fCheckCity)  and (fShowListCity)) or
  ((fCheckProfissao) and (fShowListProfissao)) or
  ((fCheckEscolaridade) and (fShowListEscolaridade))
  and (key = #13) then GetList;

   if fCheckMoney then
   begin
    if (Key in ['0'..'9',Chr(VK_BACK)]) then
    begin
      // limita-se a 23 caracteres seno haver um erro na funo StrToInt64()
      if (key in ['0'..'9']) and (Length(Trim(TMaskEditHV(Self).Text))>23) then
        key := #0;

      Texto2 := '0';
      Texto := Trim(TMaskEditHV(Self).Text)+Key;
      for i := 1 to Length(Texto) do
        if Texto[i] in ['0'..'9'] then
          Texto2 := Texto2 + Texto[i];

      if key = chr(vk_back) then
        Delete(Texto2,Length(Texto2),1);

      // formato o texto que depois ser colocado no MaskEditHV
      if fShowCurrencyString then
        Texto2 := FormatFloat('R$ #,0.00',StrToInt64(Texto2)/100)
      else
        Texto2 := FormatFloat('#,0.00',StrToInt64(Texto2)/100);

      TMaskEditHV(Self).Text := Texto2;
      TMaskEditHV(Self).SelStart := Length(Texto2);
   end;

   Key := #0;
 end;
end;

procedure TMaskEditHV.Click;
begin
  inherited;
  if not fCheckMoney then Exit;

    // retorno o cursor para o final do texto, caso tenha sido utilizado
   // o mouse para mover o cursor dentro do MaskEditHV
   TMaskEditHV(Self).SelStart := Length(TMaskEditHV(Self).Text);
end;


procedure TMaskEditHV.DoEnter;
begin
  inherited;
  Self.Color := fCorAtiva;
end;


procedure TMaskEditHV.DoExit;
procedure GoTabAndAbort;
begin
  GoTab;
  Abort;
end;
begin
 // if AllDisabledCheckFunctions then RestoreDefaultCheckFunctions;
  Inherited;
  Self.Color          := fCorNaoAtiva;

  if (DateTimeFormat) and (fCheckDateTime) then
  begin
     if (fCheckEmptyDateTime) then
     begin
       if (EmptyDateTime) then
       begin
         Application.MessageBox(Pchar(Format(InvalidDateTimeMSG, [DateTimeName])), PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
         SetFocus;
         Exit;
       end;
       if (EmptyExists) or (not Self.IsValidDateAndTime) then
       begin
         SetFocus;
         Exit;
       end;

       GoTabAndAbort;
       Exit;
     end
     else //end (fCheckEmptyDateTime)
     begin
       if (bSilentError) and (IsSilentError) then
       begin
         SetFocus;
         Exit;
       end;

       if (EmptyDateTime) then GoTabAndAbort;
       if (EmptyExists) or (not Self.IsValidDateAndTime) then
       begin
         SetFocus;
         Exit;
       end;

       GoTabAndAbort;
       Exit;
     end;
  end; // end  fCheckDateTime

  if (DateFormat) and (fCheckDate) and (fCheckEmptyDate) then
  begin
    if Assigned(MonthCalendar) then
    begin
      if (MonthCalendar.Visible) then
      begin
        Self.Text := DateToStr(MonthCalendar.Date);
        MonthCalendar.Visible := False;
        GoTabAndAbort;
        Exit;
      end;
    end;

    if (EmptyDate) then
    begin
      Application.MessageBox(Pchar(Format(InvalidDateMSG, [DateName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
      SetFocus;
      Exit;
    end;

    if (EmptyExists) then
    begin
      SetFocus;
      Exit;
    end;

    if (not Self.IsValidDate) then
    begin
      SetFocus;
      Exit;
    end;

    GoTabAndAbort;
    Exit;
  end
  else if (DateFormat) and (fCheckDate) then
  begin
    if Assigned(MonthCalendar) then
    begin
      if (MonthCalendar.Visible) then
      begin
        Self.Text := DateToStr(MonthCalendar.Date);
        MonthCalendar.Visible := False;
        GoTabAndAbort;
        Exit;
      end;
    end;

    if (bSilentError) and (IsSilentError) then
    begin
      SetFocus;
      Exit;
    end;

    if (EmptyExists) and not (EmptyDate) then
    begin
      SetFocus;
      Exit;
    end;

    if (EmptyDate) then GoTabAndAbort;
    if not (Self.IsValidDate) then
    begin
      SetFocus;
      Exit;
    end;

    GoTabAndAbort;
    Exit;
  end  // end  fCheckDate

  else if (TimeFormat) and (fCheckTime) then
  begin
    if (fCheckEmptyTime) then
    begin
      if (EmptyTime) then
      begin
        Application.MessageBox(Pchar(Format(InvalidTimeMSG, [TimeName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
      if (EmptyExists) or (not Self.IsValidTime) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
    end //end  fCheckEmptyTime
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyTime) then GoTabAndAbort;

      if (EmptyExists) or (not Self.IsValidTime) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
    end;

    Exit;
  end // end  fCheckTime
  else if (CPFFormat) and (fCheckCPF) then
  begin
    if (fCheckEmptyCPF) then
    begin
      if (EmptyCPF) then
      begin
        Application.MessageBox(Pchar(Format(InvalidCPFMSG, [CPFName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCPF) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyCPF) then GoTabAndAbort;
      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCPF) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end;

    Exit;
  end // end  fCheckCPF
  else if (CNPJFormat) and (fCheckCNPJ) then
  begin
    if (fCheckEmptyCNPJ) then
    begin
      if (EmptyCNPJ) then
      begin
        Application.MessageBox(Pchar(Format(InvalidCNPJMSG, [CNPJName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCNPJ) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyCNPJ) then GoTabAndAbort;
      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCNPJ) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end;

    Exit;
  end  // end  fCheckCNPJ
  else if (CEPFormat) and (fCheckCEP) then
  begin
    if (fCheckEmptyCEP) then
    begin
      if (EmptyCEP) then
      begin
        Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCEP) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyCEP) then GoTabAndAbort;

      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidCEP) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end;
  end // end  fCheckCEP
  else if (TelFormat1 or TelFormat2) and (fCheckTel) then
  begin
    if (CheckEmptyTEL) then
    begin
      if (EmptyTel) then
      begin
        Application.MessageBox(Pchar(Format(InvalidTelMSG, [TELName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      {if (not Self.IsValidTel) then
      begin
        SetFocus;
        Exit;
      end;
      }
      GoTabAndAbort;
      Exit;
    end
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyTel) then GoTabAndAbort;
      if (EmptyExists) then
      begin
        SetFocus;
        Exit;
      end;

      {if (not Self.IsValidTel) then
      begin
        SetFocus;
        Exit;
      end;
      }
      GoTabAndAbort;
      Exit;
    end;

    Exit;
  end  // end  fCheckTel
  else if (fCheckEmail) then
  begin
    if (CheckEmptyEmail) then
    begin
      if (EmptyEmail) then
      begin
        Application.MessageBox(Pchar(Format(InvalidEmailMSG, [EmailName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      if (not Self.IsValidEmail) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end
    else
    begin
      if (bSilentError) and (IsSilentError) then
      begin
        SetFocus;
        Exit;
      end;

      if (EmptyEmail) then GoTabAndAbort;

      if (not Self.IsValidEmail) then
      begin
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end;

    Exit;
  end  // end  fCheckEmail
  else if (fCheckProfissao) then
  begin
    if (CheckEmptyProfissao) then
    begin
      if (EmptyProfissao) then
      begin
        if (fShowInvalidProfissaoMSG) then
          Application.MessageBox(Pchar(Format(InvalidProfissaoMSG, [ProfissaoName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end  // end  fCheckProfissao
  else if (fCheckEscolaridade) then
  begin
    if (CheckEmptyEscolaridade) then
    begin
      if (EmptyEscolaridade) then
      begin
        if (fShowInvalidEscolaridadeMSG) then
          Application.MessageBox(Pchar(Format(InvalidEscolaridadeMSG, [EscolaridadeName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end  // end  fCheckEscolaridade
  else if (fCheckUserName) then
  begin
    if (CheckEmptyUserName) then
    begin
      if (EmptyUserName) then
      begin
        if (fShowInvalidUserNameMSG) then
          Application.MessageBox(Pchar(Format(InvalidUserNameMGS, [UserName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end  // end  fCheckUserName
  else if (fCheckAddress) then
  begin
    if (CheckEmptyAddress) then
    begin
      if (EmptyAddress) then
      begin
        if (fShowInvalidAddressMSG) then
          Application.MessageBox(Pchar(Format(InvalidAddressMSG, [AddressName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end  // end  fCheckAddress
  else if (fCheckSector) then
  begin
    if (CheckEmptySector) then
    begin
      if (EmptySector) then
      begin
        if (fShowInvalidSectorMSG) then
          Application.MessageBox(Pchar(Format(InvalidSectorMSG, [SectorName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end  // end  fCheckSector
  else if (fCheckState) then
  begin
    fEstado := Self.Text;

    if (CheckEmptyState) then
    begin
      if (EmptyState) then
      begin
        if (fShowInvalidStateMSG) then
          Application.MessageBox(Pchar(Format(InvalidStateMSG, [StateName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end  fCheckState
  else if (fCheckCity) then
  begin
    if (CheckEmptyCity) then
    begin
      if (EmptyCity) then
      begin
        if (fShowInvalidCityMSG) then
        Application.MessageBox(Pchar(Format(InvalidCityMSG, [CityName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckCity
  else if (fCheckComplemento) then
  begin
    if (CheckEmptyComplemento) then
    begin
      if (EmptyComplemento) then
      begin
        if (fShowInvalidComplementoMSG) then
        Application.MessageBox(Pchar(Format(InvalidComplementoMSG, [ComplementoName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckComplemento
  else if (fCheckMoney) then
  begin
    if (CheckEmptyMoney) then
    begin
      if (EmptyMoney) then
      begin
        Application.MessageBox(Pchar(Format(InvalidMoneyMSG, [MoneyName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;

      GoTabAndAbort;
      Exit;
    end;
  end  // end fCheckMoney
  else if (fCheckUser01) then
  begin
    if (CheckEmptyUser01) then
    begin
      if (EmptyUser01) then
      begin
        if (fShowInvalidUser01MSG) then
        Application.MessageBox(Pchar(Format(InvalidUser01MSG, [User01Name])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckUser01
  else if (fCheckUser02) then
  begin
    if (CheckEmptyUser02) then
    begin
      if (EmptyUser02) then
      begin
        if (fShowInvalidUser02MSG) then
        Application.MessageBox(Pchar(Format(InvalidUser02MSG, [User02Name])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckUser02
  else if (fCheckUser03) then
  begin
    if (CheckEmptyUser03) then
    begin
      if (EmptyUser03) then
      begin
        if (fShowInvalidUser03MSG) then
        Application.MessageBox(Pchar(Format(InvalidUser03MSG, [User03Name])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckUser03
  else if (fCheckUser04) then
  begin
    if (CheckEmptyUser04) then
    begin
      if (EmptyUser04) then
      begin
        if (fShowInvalidUser04MSG) then
        Application.MessageBox(Pchar(Format(InvalidUser04MSG, [User04Name])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end // end fCheckUser04
  else if (fCheckUser05) then
  begin
    if (CheckEmptyUser05) then
    begin
      if (EmptyUser05) then
      begin
        if (fShowInvalidUser05MSG) then
        Application.MessageBox(Pchar(Format(InvalidUser05MSG, [User05Name])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
        SetFocus;
        Exit;
      end;
    end;
    GoTabAndAbort;
    Exit;
  end; // end fCheckUser05
  
 // inherited;
end;

constructor TMaskEditHV.Create(AOwner: TComponent);
begin
  inherited;
  with Self do
  begin;
    FInvalidDateMSG           := '%s Invlida!';
    fInvalidTimeMSG           := '%s Invlida!';
    fInvalidDateTimeMSG       := '%s Invlida!';
    fInvalidCPFMSG            := '%s Invlido!';
    fInvalidCNPJMSG           := '%s Invlido!';
    fInvalidCEPMSG            := '%s Invlido!';
    fInvalidTelMSG            := '%s Invlido!';
    fInValidUserNameMSG       := '%s Invlido!';
    fInvalidAddressMSG        := '%s Invlido!';
    fInvalidSectorMSG         := '%s Invlido!';
    fInvalidCityMSG           := '%s Invlida!';
    fInvalidStateMSG          := '%s Invlido!';
    fInvalidEmailMSG          := '%s Invlido!';
    fInvalidProfissaoMSG      := '%s Invlida!';
    fInvalidEscolaridadeMSG   := '%s Invlida!';
    fInvalidComplementoMSG    := '%s Invlido!';
    fInvalidMoneyMSG          := '%s No preenchido!';
    fInvalidUser01MSG         := '%s Invlido!';
    fInvalidUser02MSG         := '%s Invlido!';
    fInvalidUser03MSG         := '%s Invlido!';
    fInvalidUser04MSG         := '%s Invlido!';
    fInvalidUser05MSG         := '%s Invlido!';

    fCannotContainEmptyCaracter := 'O campo %s no est totalmente preenchido!';
    fEstado               := 'GO'; //Estado de Gois, como default ...
    //fShowCurrencyString   := False;

    if (fCheckMoney) and (fShowCurrencyString) then
      Self.Text := FormatFloat('R$ #,0.00',0)
    else if (fCheckMoney) then
      Self.Text := FormatFloat('#,0.00',0);

    fShowListState        := False;
    fShowListCity         := False;
    fShowListProfissao    := False;
    fShowListEscolaridade := False;
    fShowF1Date           := False;
    fEstadoCEPAutoDetect  := True;
    fTelDDDFormat       := False;
    fTitleErrorMSG      := 'Erro';
    fTitleWarningMSG    := 'Ateno';
    fTitleOKMSG         := 'OK';
    fDateName           := 'Data';
    fDateTimeName       := 'Data/Hora';
    fTimeName           := 'Hora';
    fCEPName            := 'CEP';
    fCPFName            := 'CPF';
    fCNPJName           := 'CNPJ';
    fTELName            := 'Telefone';
    fUserName           := 'Usurio';
    fAddressName        := 'Endereo';
    fSectorName         := 'Setor';
    fCityName           := 'Cidade';
    fStateName          := 'Estado';
    fEmailName          := 'Email';
    fProfissaoName      := 'Profisso';
    fEscolaridadeName   := 'Escolaridade';
    fComplementoName    := 'Complemento';
    fMoneyName          := 'Dinheiro';
    fUser01Name         := 'User01Name';
    fUser02Name         := 'User02Name';
    fUser03Name         := 'User03Name';
    fUser04Name         := 'User04Name';
    fUser05Name         := 'User05Name';
    fShowInvalidDateMSG := True;
    fShowInvalidDateTimeMSG := True;
    fShowInvalidTimeMSG := True;
    fShowInvalidCPFMSG  := True;
    fShowInvalidCNPJMSG := True;
    fShowInvalidCEPMSG  := True;
    fShowInvalidTelMSG  := True;
    fShowInvalidUserNameMSG := True;
    fShowInvalidAddressMSG := True;
    fShowInvalidSectorMSG  := True;
    fShowInvalidSectorMSG  := True;
    fShowInvalidCityMSG    := True;
    fShowInvalidStateMSG   := True;
    fShowInvalidEmailMSG   := True;
    fShowInvalidProfissaoMSG := True;
    fShowInvalidEscolaridadeMSG := True;
    fShowInvalidComplementoMSG := True;
    fShowInvalidMoneyMSG   := True;
    fShowInvalidUser01MSG  := True;
    fShowInvalidUser02MSG  := True;
    fShowInvalidUser03MSG  := True;
    fShowInvalidUser04MSG  := True;
    fShowInvalidUser05MSG  := True;
    fCheckEmptyDate     := False;
    fCheckEmptyDateTime := False;
    fCheckEmptyTime     := False;
    fCheckEmptyCPF      := False;
    fCheckEmptyCNPJ     := False;
    fCheckEmptyCEP      := False;
    fCheckEmptyTel      := False;
    fCheckEmptyUserName := False;
    fCheckEmptyAddress  := False;
    fCheckEmptySector   := False;
    fCheckEmptyCity     := False;
    fCheckEmptyState    := False;
    fCheckEmptyEmail    := False;
    fCheckEmptyProfissao := False;
    fCheckEmptyEscolaridade := False;
    fCheckEmptyComplemento  := False;
    fCheckEmptyMoney    := False;
    fCheckEmptyUser01   := False;
    fCheckEmptyUser02   := False;
    fCheckEmptyUser03   := False;
    fCheckEmptyUser04   := False;
    fCheckEmptyUser05   := False;
    Width               := 75;
    bSilentError        := False;
    CharCase            := ecUpperCase;
    fVersion            := cVersion;
    fCorAtiva           := $00E1FFFF; //$00E1FFFF
    fCorNaoAtiva        := clWindow;
    Self.Color          := fCorNaoAtiva;
  end;
end;

function TMaskEditHV.EmptyDate: Boolean;
begin
  Result := (Self.Text = '  /  /    ');
end;

function TMaskEditHV.EmptyDateTime: Boolean;
begin
  Result := (Self.Text = '  /  /       :  ');
end;

function TMaskEditHV.EmptyTime: Boolean;
begin
  Result := (Self.Text = '  :  ');
end;

function TMaskEditHV.EmptyCPF: Boolean;
begin
  Result := (Self.Text = '   .   .   -  ');
end;

function TMaskEditHV.EmptyCNPJ: Boolean;
begin
  Result := (Self.Text = '  .   .   /    -  ');
end;

function TMaskEditHV.EmptyCEP: Boolean;
begin
  Result := (Self.Text = '  .   -   ');
end;

function TMaskEditHV.EmptyTel: Boolean;
begin
  if TelFormat1 then Result := EmptyTel1
  else if TelFormat2 then Result := EmptyTel2;
end;

function TMaskEditHV.EmptyTel1: Boolean;
begin
  Result := (Self.Text = '(  )     -    ');
end;

function TMaskEditHV.EmptyTel2: Boolean;
begin
  Result := (Self.Text = '(   )     -    ');
end;


function TMaskEditHV.EmptyAddress: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyCity: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyEmail: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyProfissao: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyEscolaridade: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptySector: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyState: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyUserName: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyComplemento: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyMoney: Boolean;
var
  auxEmptyMoney: string;
begin
  if fShowCurrencyString then
    auxEmptyMoney := FormatFloat('R$ #,0.00',0)
  else
    auxEmptyMoney := FormatFloat('#,0.00',0);

  Result := (Self.Text = auxEmptyMoney) or (Self.Text = '');
end;

function TMaskEditHV.EmptyUser01: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyUser02: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyUser03: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyUser04: Boolean;
begin
  Result := (Self.Text = '');
end;

function TMaskEditHV.EmptyUser05: Boolean;
begin
  Result := (Self.Text = '');
end;


function TMaskEditHV.HourExistsToo: Boolean;
begin
  Result := (System.Pos(':', Copy(Self.Text,14,1)) = 1);
end;


function TMaskEditHV.IsValidDate(const FStringDate: string): Boolean;
begin
  Result := False;
  if (FStringDate = '') or (not DateFormat) then Exit;

  if HourExistsToo then          //formato: dd/mm/yyyy hh:mm
    Result := (DateUtils.IsValidTime( (StrToIntDef(System.Copy(FStringDate,12,2),0)), (StrToIntDef(System.Copy(FStringDate,15,2),0)),
     0, 0))
    and (DateUtils.IsValidDate( (StrToIntDef(System.Copy(FStringDate,7,4),0)), (StrToIntDef(System.Copy(FStringDate,4,2),0)),
    (StrToIntDef(Copy(FStringDate,1,2),0)))) and not (EmptyHourExistsInDateTimeFormat)
  else
    Result := DateUtils.IsValidDate( (StrToIntDef(System.Copy(FStringDate,7,4),0)), (StrToIntDef(System.Copy(FStringDate,4,2),0)),
    (StrToIntDef(Copy(FStringDate,1,2),0)));

  if (not Result) and (fShowInvalidDateTimeMSG) and (DateTimeFormat) then
    Application.MessageBox(Pchar(Format(InvalidDateTimeMSG,[DateTimeName])), Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR)
  else if (not Result) and (fShowInvalidDateMSG) and (DateFormat) and (not DateTimeFormat)  then
    Application.MessageBox(Pchar(Format(InvalidDateMSG, [DateName])),  Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR)
end;

function TMaskEditHV.IsValidDate: Boolean;
begin
//  Result := (EmptyExists);
//  if not Result then
  Result := Self.IsValidDate(Self.Text) and (not EmptyDate) ;
end;

function TMaskEditHV.IsValidTime(const FStringTime: string): Boolean;
begin
  Result := False;  //hh:mm
  if (FStringTime = '') or (EmptyTime) or (EmptyExists) or (not TimeFormat) then Exit;
  Result := DateUtils.IsValidTime( (StrToIntDef(System.Copy(FStringTime,1,2),0)),
  (StrToIntDef(System.Copy(FStringTime,4,5),0)),0,0);

  if (not Result) and (fShowInvalidTimeMSG) then
    Application.MessageBox(Pchar(Format(InvalidTimeMSG, [TimeName])),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);
end;

function TMaskEditHV.IsValidTime: Boolean;
begin
  Result := Self.IsValidTime(Self.Text);
end;

function TMaskEditHV.IsValidDateAndTime: Boolean;
begin
  Result := Self.IsValidDate(Self.Text);
end;


function TMaskEditHV.IsValidCEP: Boolean;
var
  cCEP1, i: Integer;
  cCep: string;
begin
  Result  := False;

  cCep    := Self.Text;

  if EstadoCEPAutoDetect then //detecta automaticamente se existe um objeto j contendo o estado preenchido.
  begin                      //Se sim, j obtm seu valor e valida conforme o valor do CEP fornecido.
    for I := 0 to pred(Owner.ComponentCount) do
    begin
      if (Owner.Components[I] is TMaskeditHV) then
      begin
        if (TMaskeditHV(Owner.Components[I]).CheckState) and (TMaskeditHV(Owner.Components[I]).Estado <> '') then
        begin
          fEstado :=  TMaskeditHV(Owner.Components[I]).Estado;
          Break;
        end;
      end;
    end;
  end;

  if (fEstado = '') then
  begin
    Application.MessageBox('Favor informar o Estado!',Pchar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
    Exit;
  end;

  if (cCep = '') or (fEstado = '') or (EmptyCEP) or (EmptyExists) then Exit;

  cCep := SysUtils.StringReplace(cCep,'.','',[rfReplaceAll]);
  cCep := SysUtils.StringReplace(cCep,'-','',[rfReplaceAll]);
  cCep := WithoutAllSpaces(cCep);

  fEstado := SysUtils.StringReplace(fEstado,'.','',[rfReplaceAll]);
  fEstado := SysUtils.StringReplace(fEstado,'-','',[rfReplaceAll]);
  fEstado := WithoutAllSpaces(fEstado);
  //ShowMessage('fEstado ' + fEstado + ' cCep ' + cCep);

  cCep := copy(cCep,1,5) + copy(cCep,7,3);
  cCEP1 := StrToInt(copy(cCep,1,3));
  if Length(trim(cCep)) > 0 then
    begin
      if (StrToInt(cCep) <= 1000000.0) then
      begin
        if fShowInvalidCEPMSG then
          Application.MessageBox('CEP tem que ser maior que [10000-000]',Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
        Result := False
       end
      else
      begin
        {if Length(trim(copy(cCep,6,3))) < 3 then Result := False else   }
        if (fEstado = 'SP') then
        begin
          Result := (cCEP1 >= 10 ) and (cCEP1 <= 199);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de SP, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 10 e 199.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'RJ') then
        begin
          Result := (cCEP1 >= 200) and (cCEP1 <= 289);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do RJ, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 200 e 289.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'ES') then
        begin
          Result := (cCEP1 >= 290) and (cCEP1 <= 299);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do ES, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 290 e 299.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'MG') then
        begin
          Result := (cCEP1 >= 300) and (cCEP1 <= 399);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de MG, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 300 e 399.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'BA') then
        begin
          Result := (cCEP1 >= 400) and (cCEP1 <= 489);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado da BA, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 400 e 489.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'SE') then
        begin
          Result := (cCEP1 >= 490) and (cCEP1 <= 499);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de SE, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 490 e 499.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'PE') then
        begin
          Result := (cCEP1 >= 500) and (cCEP1 <= 569);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de PE, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 500 e 569.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'AL') then
        begin
          Result := (cCEP1 >= 570) and (cCEP1 <= 579);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de AL, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 570 e 579.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'PB') then
        begin
          Result := (cCEP1 >= 580) and (cCEP1 <= 589);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado da PB, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 580 e 589.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'RN') then
        begin
          Result := (cCEP1 >= 590) and (cCEP1 <= 599);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do RN, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 590 e 599.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'CE') then
        begin
          Result := (cCEP1 >= 600) and (cCEP1 <= 639);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do CE, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 600 e 639.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'PI') then
        begin
          Result := (cCEP1 >= 640) and (cCEP1 <= 649);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do PI, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 640 e 649.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'MA') then
        begin
          Result := (cCEP1 >= 650) and (cCEP1 <= 659);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do MA, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 650 e 659.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'PA') then
        begin
          Result := (cCEP1 >= 660) and (cCEP1 <= 688);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do PA, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 660 e 688.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'AM') then
        begin
          Result := ((cCEP1 >= 690) and (cCEP1 <= 692) or (cCEP1 >= 694) and
          (cCEP1 <= 698));
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do AM, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 690 e 692 ou entre 694 e 698.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'AP') then
        begin
          Result := (cCEP1 = 689);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do AP, os trs nmeros iniciais do'#13#10 +
            'CEP devem ser 689.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'RR') then
        begin
          Result := (cCEP1 = 693);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de RR, os trs nmeros iniciais do'#13#10 +
            'CEP devem ser 693.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'AC') then
        begin
          Result := (cCEP1 = 699);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do AC, os trs nmeros iniciais do'#13#10 +
            'CEP devem ser 699.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if ((fEstado = 'DF') or (fEstado = 'GO')) then
        begin
          Result := (cCEP1 >= 000) and (cCEP1 <= 999);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do DF ou GO, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 000 e 999.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'TO') then
        begin
          Result := (cCEP1 >= 770) and (cCEP1 <= 779);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de TO, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 770 e 779.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'MT') then
        begin
          Result := (cCEP1 >= 780) and (cCEP1 <= 788);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do MT, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 780 e 788.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'MS') then
        begin
          Result := (cCEP1 >= 790) and (cCEP1 <= 799);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do MS, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 790 e 799.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'RO') then
        begin
          Result := (cCEP1 = 789);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de RO, os trs nmeros iniciais do'#13#10 +
            'CEP devem ser 789.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'PR') then
        begin
          Result := (cCEP1 >= 800) and (cCEP1 <= 879);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do PR, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 800 e 879.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'SC') then
        begin
          Result := (cCEP1 >= 880) and (cCEP1 <= 899);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado de SC, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 880 e 899.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end
        else
        if (fEstado = 'RS') then
        begin
          Result := (cCEP1 >= 900) and (cCEP1 <= 999);
          if not Result then
          begin
            if fShowInvalidCEPMSG then
            Application.MessageBox(Pchar(Format(InvalidCEPMSG, [CEPName]) + #13#10'Erro: No Estado do RS, os trs nmeros iniciais do'#13#10 +
            'CEP devem estar entre 900 e 999.'),Pchar(TitleErrorMSG), MB_OK + MB_ICONERROR);
            SetFocus;
            Exit;
          end;
        end;
      end;
    end
    else Result := True;

//  if Result then ShowMessage('result = true') else ShowMessage('result = false');

//  if (not Result) and (fShowInvalidCEPMSG) and (not (StrToInt(cCep) <= 1000000.0)) then
//    Application.MessageBox(Pchar(InvalidCEPMSG),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);
end;

                                                                   {
function TMaskEditHV.IsValidTel(const fStringTel: string): Boolean;
function EmptyExistsTelFormat1: Boolean;
begin
  Self.EditMask := '(99)9999-9999;1;_';
  Result := EmptyExists;
  Self.EditMask := '(99) 9999-9999;1;_';
end;
function EmptyExistsTelFormat2: Boolean;
begin
  Self.EditMask := '(999)9999-9999;1;_';
  Result := EmptyExists;
  Self.EditMask := '(999) 9999-9999;1;_';
end;

begin
  Result := False;

  if (TelFormat1) then
  begin
    Result := (EmptyExistsTelFormat1);
    if not (Result) then
      if (fShowInvalidTelMSG) and (not EmptyTel) then
        Application.MessageBox(Pchar(Format(InvalidTelMSG,[TELName])),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);
  end
  else if (TelFormat2) then
  begin
    Result := true;// (EmptyExistsTelFormat2);
    if not (Result) then
      if (fShowInvalidTelMSG) and (not EmptyTel) then
        Application.MessageBox(Pchar(Format(InvalidTelMSG,[TELName])),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);
  end;
end;

function TMaskEditHV.IsValidTel: Boolean;
begin
  Result := (Self.IsValidTel(Self.Text));
end;
}

function TMaskEditHV.IsValidEmail: Boolean;
const
  vet_valido: array [0..35] of string = ('0','1','2','3','4','5','6','7',
  '8','9','a','b','c','d','e','f', 'g','h','i','j','k','l','m','n', 'o',
  'p','q','r','s','t','u','v', 'w','x','y','z');
const
  msg1 = 'Caractere(s) invlido(s) no incio do e-mail.';
  msg2 = 'Smbolo @ no foi encontrado.';
  msg3 = 'Excesso do smbolo @.';
  msg4 = 'Caractere(s) invlido(s) antes do smbolo @.';
  msg5 = 'Caractere(s) invlido(s) depois do smbolo @.';
  msg6 = 'Agrupamento de caractere(s) invlido(s) a esqueda do @.';
  msg7 = 'No existe ponto(s) digitado(s).';
  msg8 = 'Ponto encontrado no final do e-mail.';
  msg9 = 'Ausncia de caractere(s) aps o ltimo ponto.';
  msg10 = 'Excesso de ponto(s) a direita do @.';
  msg11 = 'Ponto(s) disposto(s) de forma errada aps o @.';
  msg12 = 'Caractere(s) invlido(s) antes do ponto.';
  msg13 = 'Caractere(s) invlido(s) depois do ponto.';
var
  i, j, tam_email, simb_arroba, simb_arroba2, qtd_arroba, qtd_pontos,
  qtd_pontos_esq, qtd_pontos_dir, posicao, posicao2, ponto, ponto2: integer;
  vet_email: array [0..49] of string; //50 posies, capacidade do Edit
  email, msg: string;
begin
  FEmailMessage := ''; //essa inicializao significa que enquanto varivel vazia est tudo OK ...
  qtd_pontos:= 0; qtd_pontos_esq:= 0; qtd_pontos_dir:= 0; qtd_arroba:= 0;
  posicao:=0; posicao2:=0; simb_arroba:=0; simb_arroba2:=0; ponto:= 0;
  ponto2:= 0; msg:='';
  Result:= True;
  email := Self.Text;
 //Verificando parte inicial do E-mail
  tam_email:= Length(email);
  for i:= 0 to tam_email-1 do
  begin
    vet_email[i]:= Copy(email,i+1,1);
    if vet_email[i] = '@' then
    begin
      Inc(qtd_arroba);
      posicao:= i;
    end;
  end;
  if ((vet_email[0] = '@') or (vet_email[0] = '.') or (vet_email[0] = '-')) then
  begin
    Result:= False;
    msg:= msg1;
  end;
  //Verificando se tem o smbolo @ e quantos tem
  if qtd_arroba < 1 then
  begin
    Result:= False;
    msg:= msg2;
  end
  else if qtd_arroba > 1 then
  begin
    Result:= False;
    msg:= msg3 + ' Encontrado(s): '+IntToStr(qtd_arroba)+'.';
  end
  else
  //Verificando o que vem antes e depois do smbolo @
  begin
  for i:=0 to 35 do
  begin
    if vet_email[posicao-1] <> vet_valido[i] then Inc(simb_arroba)
    else Dec(simb_arroba);
    if vet_email[posicao+1] <> vet_valido[i] then Inc(simb_arroba2)
    else Dec(simb_arroba2);
  end;
  if simb_arroba = 36 then
  begin
   //Antes do arroba h um smbolo desconhecido do vetor vlido
   Result:= False;
   msg:= msg4;
  end
  else if simb_arroba2 = 36 then
  begin
   //Depois do arroba h um smbolo desconhecido do vetor vlido
    Result:= False;
    msg:= msg5;
  end
  end;
  //Verificando se h pontos e quantos, e Verificando parte final do e-mail
  for j:=0 to tam_email-1 do
  if vet_email[j] = '-' then
  if ((vet_email[j-1] = '.') or (vet_email[j-1] = '-')) then
  begin
    Result:= False;
    msg:= msg6;
  end;
  for i:=0 to tam_email-1 do
  if vet_email[i] = '.' then
  begin
    Inc(qtd_pontos);
    posicao2:= i+1;
    if i > posicao then Inc(qtd_pontos_dir)
    else Inc(qtd_pontos_esq);
    if ((vet_email[i-1] = '.') or (vet_email[i-1] = '-')) then
    begin
      Result:= False;
      msg:= msg6;
    end;
  end;
  if qtd_pontos < 1 then
  begin
    Result:= False;
    msg:= msg7;
  end
  else if vet_email[tam_email-1] = '.' then
  begin
    Result:= False;
    msg:= msg8;
  end
  else if vet_email[tam_email-2] = '.' then
  begin
    Result:= False;
    msg:= msg9;
  end
  else if qtd_pontos_dir > 2 then
  begin
    Result:= False;
    msg:= msg10 + ' Encontrado(s): '+
    IntToStr(qtd_pontos)+#10+'Encontrado(s) a direita do @: '+
    IntToStr(qtd_pontos_dir)+'.';
  end
  else if (not ((((tam_email - posicao2) = 3) and (qtd_pontos_dir = 1)) or
  (((tam_email - posicao2) = 2) and (qtd_pontos_dir = 2)) or
  (((tam_email - posicao2) = 2) and (qtd_pontos_dir = 1)))) then
  begin
    Result:= False;
    msg:= msg11 +#10+ 'Encontrado(s) a esquerda do @: '+
    IntToStr(qtd_pontos_esq) +#10+ 'Encontrado(s) a direita do @: '+
    IntToStr(qtd_pontos_dir)+'.';
  end
  else
  //Verificando o que vem antes e depois do ponto
  begin
  for i:=0 to 35 do
  begin
    if vet_email[posicao2-2] <> vet_valido[i] then Inc(ponto)
    else Dec(ponto);
    if vet_email[posicao2] <> vet_valido[i] then Inc(ponto2)
    else Dec(ponto2);
  end;
  if ponto = 36 then
  begin
   //Antes do ponto h um smbolo desconhecido do vetor vlido
    Result:= False;
    msg:= msg12;
  end
  else if ponto2 = 36 then
  begin
    //Depois do ponto h um smbolo desconhecido do vetor vlido
    Result:= False;
    msg:= msg13;
  end
  end;
  //Verificao final
  if not Result then
  begin
    msg:= msg +#10+ 'Formato de E-mail no aceitvel!!';
    FEmailMessage := msg;
    fInvalidEmailMSG := FEmailMessage;
    Application.MessageBox(Pchar(Format(InvalidEmailMSG, [EmailName])),PChar(TitleWarningMSG),MB_OK + MB_ICONWARNING);
   // Application.MessageBox(Pchar(msg)
  //  MessageDlg(msg,mtWarning,[mbRetry],0);
  end;
end;

function TMaskEditHV.IsValidCPF(const FStringCPF: string): Boolean;
function ValidCPF(const num: string): boolean;
var
  n1,n2,n3,n4,n5,n6,n7,n8,n9: integer;
  d1,d2: integer;
  digitado, calculado: string;
begin
  n1:=StrToInt(num[1]);
  n2:=StrToInt(num[2]);
  n3:=StrToInt(num[3]);
  n4:=StrToInt(num[4]);
  n5:=StrToInt(num[5]);
  n6:=StrToInt(num[6]);
  n7:=StrToInt(num[7]);
  n8:=StrToInt(num[8]);
  n9:=StrToInt(num[9]);
  d1:=n9*2+n8*3+n7*4+n6*5+n5*6+n4*7+n3*8+n2*9+n1*10;
  d1:=11-(d1 mod 11);
  if d1>=10 then
    d1:=0;
    d2:=d1*2+n9*3+n8*4+n7*5+n6*6+n5*7+n4*8+n3*9+n2*10+n1*11;
    d2:=11-(d2 mod 11);
  if d2>=10 then d2:=0;
    calculado:=inttostr(d1)+inttostr(d2);
    digitado:=num[10]+num[11];
    Result := (calculado=digitado);
end;

var
  auxStr: String;
begin
  Result := False;
  if (FStringCPF = '') or (EmptyCPF) or (EmptyExists) then Exit;

  auxStr := SysUtils.StringReplace(FStringCPF,'.','',[rfReplaceAll]);
  auxStr := SysUtils.StringReplace(auxStr,'-','',[rfReplaceAll]);
  auxStr := WithoutAllSpaces(auxStr);
  Result := ValidCPF(auxStr);
  if (not Result) and (fShowInvalidCPFMSG) then
    Application.MessageBox(Pchar(Format(InvalidCPFMSG, [CPFName])),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);
end;


function TMaskEditHV.IsValidCPF: Boolean;
begin
  Result := Self.IsValidCPF(Self.Text);
end;

function TMaskEditHV.IsValidCNPJ(const FStringCNPJ: string): Boolean;
var
  dig1,dig2,i,cal : integer;
  digitos : array [1..14] of integer;
  controle : boolean;
begin
  controle := false;
  if not((pos(' ',FStringCNPJ)<>0) or (FStringCNPJ = '')) then
  begin
    for i := 1 to length(FStringCNPJ) - 4 do // Copia string no vetor
    begin
      if i < 3 then
        digitos[i] := StrToInt(FStringCNPJ[i])
      else if (i >= 3) and (i < 6) then
        digitos[i] := StrToInt(FStringCNPJ[i+1])
      else if (i >= 6) and (i < 9) then
        digitos[i] := StrToInt(FStringCNPJ[i+2])
      else if (i >= 9) and (i < 13) then
        digitos[i] := StrToInt(FStringCNPJ[i+3])
      else if (i >= 13) then
        digitos[i] := StrToInt(FStringCNPJ[i+4]);
    end;
  // Testa c  --> 00.000.000.000/0000-00
  for i := 1 to 13 do
  if not((digitos[i] = 0) and (digitos[i+1] = 0)) then
  begin
    controle := true;
    break;
  end;

  if controle then // primeiro digito
  begin
    cal := (5 * digitos[1])+(4 * digitos[2])+(3 * digitos[3])+(2 * digitos[4])+
    (9 * digitos[5])+(8 * digitos[6])+(7 * digitos[7])+(6 * digitos[8])+
    (5 * digitos[9])+(4 * digitos[10])+(3 * digitos[11])+(2 * digitos[12]);

  if ((cal mod 11) = 1)or((cal mod 11) = 0) then
    dig1 := 0
  else
    dig1 := 11-(cal mod 11);

  if dig1 = digitos[13] then // Compara o 1 se ok vai calcular o 2 digito
  begin
    cal :=(6 * digitos[1])+(5 * digitos[2])+(4 * digitos[3])+(3 * digitos[4])+
    (2 * digitos[5])+(9 * digitos[6])+(8 * digitos[7])+(7 * digitos[8])+(6 * digitos[9])+
    (5 * digitos[10])+(4 * digitos[11])+(3 * digitos[12])+(2 * digitos[13]);

  if ((cal mod 11) = 1)or((cal mod 11) = 0) then
    dig2 := 0
  else
    dig2 := 11-(cal mod 11);
  // Testa o 2 digito, se ok cnpj valido
  if dig2 = digitos[14] then
    Result := true
  else
    Result := false;
  end
  else
    Result := false;
  end
  else
    Result := false;
  end
  else
    Result := false;

  if (not Result) and (fShowInvalidCNPJMSG) then
    Application.MessageBox(Pchar(Format(InvalidCNPJMSG, [CNPJName])),Pchar(TitleErrorMSG),MB_OK + MB_ICONERROR);  
end;

function TMaskEditHV.IsValidCNPJ: Boolean;
begin
  Result := Self.IsValidCNPJ(Self.Text);
end;

function TMaskEditHV.WithoutAllSpaces(const S: String): String;
var
  A,B: Integer;
begin
  if S='' then
  begin
    Result:='';
    exit;
  end;

  SetLength(Result,length(S));
  A:=1; B:=0;
  while A<=length(S) do
  begin
    if not (S[A] in [' ',#10,#13,#9]) then
    begin
      Inc(B);
      Result[B]:=S[A];
    end;
    Inc(A);
  end;
  SetLength(Result,B);
end;

procedure TMaskEditHV.SetCheckDate(const Valor: Boolean);
begin
  fCheckDate     := Valor;
  if fCheckDate then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '99/99/9999;1;_';
    Self.Width     := 70;
  end
end;

procedure TMaskEditHV.SetShowF1Date(const Value: Boolean);
begin
  fShowF1Date := Value;
end;

procedure TMaskEditHV.SetCheckDateTime(const Valor: Boolean);
begin
  fCheckDateTime := Valor;
  if fCheckDateTime then
  begin
    fCheckDate     := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '99/99/9999 99:99;1;_';
    Self.Width     := 100;
  end
end;

procedure TMaskEditHV.SetCheckTime(const Value: Boolean);
begin
  fCheckTime     := Value;
  if fCheckTime then
  begin
    fCheckDateTime := False;
    fCheckDate     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '99:99;1;_';
    Self.Width     := 50;
  end
end;


procedure TMaskEditHV.SetCheckCPF(const Value: Boolean);
begin
  fCheckCPF      := Value;
  if fCheckCPF then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckDate     := False;
    fCheckCEP      := False;
    fCheckCNPJ     := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '999.999.999-99;1;_';
    Self.Width     := 100;
  end
end;

procedure TMaskEditHV.SetCheckCNPJ(const Value: Boolean);
begin
  fCheckCNPJ      := Value;
  if fCheckCNPJ then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckDate     := False;
    fCheckCEP      := False;
    fCheckCPF      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '99\.999\.999\/9999\-99;1;_';
    Self.Width     := 110;
  end
end;


procedure TMaskEditHV.SetCheckCEP(const Value: Boolean);
begin
  fCheckCEP      := Value;
  if fCheckCEP then
  begin
    fCheckDateTime := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckTime     := False;
    fCheckDate     := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '99.999-999;1;_';
    Self.Width     := 70;
  end
end;


procedure TMaskEditHV.SetCheckTel(const Value: Boolean);
begin
  fCheckTel      := Value;
  if fCheckTel then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckDate     := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    if fTelDDDFormat then Self.EditMask  := '(999) 9999-9999;1;_'
    else Self.EditMask  := '(99) 9999-9999;1;_';

    Self.Width     := 100;
  end
end;


procedure TMaskEditHV.SetTelDDDFormat(const Value: Boolean);
begin
  fTelDDDFormat := Value;

  if (fCheckTel) then
  begin
    if fTelDDDFormat then Self.EditMask  := '(999) 9999-9999;1;_'
    else Self.EditMask  := '(99) 9999-9999;1;_';

    Self.Width     := 100;
  end;
end;

procedure TMaskEditHV.SetCheckAddress(const Value: Boolean);
begin
  fCheckAddress := Value;
  if fCheckAddress then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 300
  end
end;

procedure TMaskEditHV.SetCheckCity(const Value: Boolean);
begin
  fCheckCity := Value;
  if fCheckCity then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckAddress  := False;
    fCheckUserName := False;
    fCheckSector   := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end
end;

procedure TMaskEditHV.SetCheckEmail(const Value: Boolean);
begin
  fCheckEmail := Value;
  if fCheckEmail then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 300
  end
end;

procedure TMaskEditHV.SetCheckProfissao(const Value: Boolean);
begin
  fCheckProfissao := Value;
  if fCheckProfissao then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckEmail    := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckComplemento := False;
    fCheckEscolaridade := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 300
  end
end;

procedure TMaskEditHV.SetCheckEscolaridade(const Value: Boolean);
begin
  fCheckEscolaridade := Value;
  if fCheckEscolaridade then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckEmail    := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckComplemento := False;
    fCheckProfissao   := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 300
  end
end;



procedure TMaskEditHV.SetCheckSector(const Value: Boolean);
begin
  fCheckSector := Value;

  if fCheckSector then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end

end;

procedure TMaskEditHV.SetCheckState(const Value: Boolean);
begin
  fCheckState := Value;
  if fCheckState then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 30
  end

end;

procedure TMaskEditHV.SetCheckUserName(const Value: Boolean);
begin
  fCheckUserName := Value;

  if fCheckUserName then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckAddress  := False;
    fCheckSector   := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney       := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01      := False;
    fCheckUser02      := False;
    fCheckUser03      := False;
    fCheckUser04      := False;
    fCheckUser05      := False;
    Self.EditMask  := '';
    Self.Width     := 250;
  end
end;


procedure TMaskEditHV.SetCheckComplemento(const Value: Boolean);
begin
  fCheckComplemento := Value;

  if fCheckComplemento then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end
end;

procedure TMaskEditHV.SetCheckMoney(const Value: Boolean);
begin
  fCheckMoney  := Value;

  if fCheckMoney then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';

    if fShowCurrencyString then
      Self.Text := FormatFloat('R$ #,0.00',0)
    else if fCheckMoney then
      Self.Text := FormatFloat('#,0.00',0);
    Self.Width     := 80;
  end

end;


procedure TMaskEditHV.SetCheckUser01(const Value: Boolean);
begin
  fCheckUser01 := Value;

  if fCheckUser01 then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end
end;

procedure TMaskEditHV.SetCheckUser02(const Value: Boolean);
begin
  fCheckUser02 := Value;

  if fCheckUser02 then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end
end;

procedure TMaskEditHV.SetCheckUser03(const Value: Boolean);
begin
  fCheckUser03 := Value;

  if fCheckUser03 then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser04   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end

end;

procedure TMaskEditHV.SetCheckUser04(const Value: Boolean);
begin
  fCheckUser04 := Value;

  if fCheckUser04 then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser05   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end

end;

procedure TMaskEditHV.SetCheckUser05(const Value: Boolean);
begin
  fCheckUser05 := Value;

  if fCheckUser05 then
  begin
    fCheckDateTime := False;
    fCheckTime     := False;
    fCheckCPF      := False;
    fCheckCNPJ     := False;
    fCheckCEP      := False;
    fCheckTel      := False;
    fCheckUserName := False;
    fCheckAddress  := False;
    fCheckCity     := False;
    fCheckState    := False;
    fCheckEmail    := False;
    fCheckProfissao := False;
    fCheckEscolaridade := False;
    fCheckComplemento := False;
    fCheckMoney    := False;
    fShowCurrencyString := fCheckMoney;
    fCheckUser01   := False;
    fCheckUser02   := False;
    fCheckUser03   := False;
    fCheckUser04   := False;
    Self.EditMask  := '';
    Self.Width     := 200
  end

end;


procedure TMaskEditHV.SetInvalidDateMSG(const Value: string);
begin
  FInvalidDateMSG := Value;
end;

procedure TMaskEditHV.SetInvalidTimeMSG(const Value: string);
begin
  fInvalidTimeMSG := Value;
end;

procedure TMaskEditHV.SetInvalidDateTimeMSG(const Value: string);
begin
  fInvalidDateTimeMSG := Value;
end;

procedure TMaskEditHV.SetInvalidCEPMSG(const Value: string);
begin
  fInvalidCEPMSG := Value;
end;

procedure TMaskEditHV.SetInvalidCPFMSG(const Value: string);
begin
  fInvalidCPFMSG := Value;
end;

procedure TMaskEditHV.SetInvalidCNPJMSG(const Value: string);
begin
  fInvalidCNPJMSG := Value;
end;

procedure TMaskEditHV.SetInvalidTelMSG(const Value: string);
begin
  fInvalidTelMSG := Value;
end;

procedure TMaskEditHV.SetInvalidAddressMSG(const Value: string);
begin
  fInvalidAddressMSG := Value;
end;

procedure TMaskEditHV.SetInvalidCityMSG(const Value: string);
begin
  fInvalidCityMSG := Value;
end;

procedure TMaskEditHV.SetInvalidEmailMSG(const Value: string);
begin
  fInvalidEmailMSG := Value;
end;

procedure TMaskEditHV.SetInvalidProfissaoMSG(const Value: string);
begin
  fInvalidProfissaoMSG := Value;
end;

procedure TMaskEditHV.SetInvalidEscolaridadeMSG(const Value: string);
begin
  fInvalidEscolaridadeMSG := Value;
end;

procedure TMaskEditHV.SetInvalidSectorMSG(const Value: string);
begin
  fInvalidSectorMSG := Value;
end;

procedure TMaskEditHV.SetInvalidStateMSG(const Value: string);
begin
  fInvalidStateMSG := Value;
end;

procedure TMaskEditHV.SetInvalidUserNameMSG(const Value: string);
begin
  fInValidUserNameMSG := Value;
end;

procedure TMaskEditHV.SetInvalidComplementoMSG(const Value: string);
begin
  fInvalidComplementoMSG := Value;
end;

procedure TMaskEditHV.SetInvalidMoneyMSG(const Value: string);
begin
  fInvalidMoneyMSG := Value;
end;

procedure TMaskEditHV.SetInvalidUser01MSG(const Value: string);
begin
  fInvalidUser01MSG := Value;
end;

procedure TMaskEditHV.SetInvalidUser02MSG(const Value: string);
begin
  fInvalidUser02MSG := Value;
end;

procedure TMaskEditHV.SetInvalidUser03MSG(const Value: string);
begin
  fInvalidUser03MSG := Value;
end;

procedure TMaskEditHV.SetInvalidUser04MSG(const Value: string);
begin
  fInvalidUser04MSG := Value;
end;

procedure TMaskEditHV.SetInvalidUser05MSG(const Value: string);
begin
  fInvalidUser05MSG := Value;
end;

procedure TMaskEditHV.RestoreDefaultCheckFunctions;
begin
  SetCheckDate(True);
end;

function TMaskEditHV.EmptyExists: Boolean;
begin
  TrimMask;
  Result := (System.Pos(' ',Self.Text) > 0);
  UnTrimMask;

  if (Result) and (DateTimeFormat)  and (not EmptyDateTime)   and (fShowInvalidDateTimeMSG)     then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fDateTimeName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (DateFormat) and (not DateTimeFormat)  and (not EmptyDate)       and (fShowInvalidDateMSG) then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fDateName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (TimeFormat) and (not EmptyTime)       and (fShowInvalidTimeMSG) then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fTimeName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (CPFFormat)  and (not EmptyCPF)        and (fShowInvalidCPFMSG)  then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fCPFName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (CNPJFormat)  and (not EmptyCNPJ)        and (fShowInvalidCNPJMSG)  then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fCNPJName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (CEPFormat)  and (not EmptyCEP)        and (fShowInvalidCEPMSG)  then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[CEPName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (TelFormat1)  and (not EmptyTel1)        and (fShowInvalidTelMSG)  then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fTELName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR)
  else if (Result) and (TelFormat2)  and (not EmptyTel2)        and (fShowInvalidTelMSG)  then
    Application.MessageBox(Pchar(Format(fCannotContainEmptyCaracter,[fTELName])),Pchar(TitleErrorMSG),
    MB_OK + MB_ICONERROR);

end;


function TMaskEditHV.AllDisabledCheckFunctions: Boolean;
begin
  Result := not (fCheckDate and fCheckDateTime and fCheckTime and fCheckCPF and fCheckCNPJ
  and fCheckCEP and fCheckTel);
end;

function TMaskEditHV.IsSomeCheckFunctionSelected: Boolean;
begin
  Result := (fCheckDate or fCheckDateTime or fCheckTime or fCheckCPF or fCheckCNPJ
  or fCheckCEP or fCheckTel);
end;

function TMaskEditHV.FilterChar(const T : string) : string;
var
  I : integer;
begin
  Result := '';
  for I := 1 to length(T) do
    if UpCase(T[I]) in ['A'..'Z', '0'..'9', #127..#255] then
            Result := Result + T[I];
end;

function TMaskEditHV.EmptyHourExistsInDateTimeFormat: Boolean;
begin
  Result :=  (System.Pos(' ', Copy(Self.Text,12,length(Self.Text))) > 0)
end;

procedure TMaskEditHV.SetShowInvalidDateMSG(const Value: Boolean);
begin
  fShowInvalidDateMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidDateTimeMSG(const Value: Boolean);
begin
  fShowInvalidDateTimeMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidTimeMSG(const Value: Boolean);
begin
  fShowInvalidTimeMSG := Value;
end;


procedure TMaskEditHV.SetShowInvalidTelMSG(const Value: Boolean);
begin
  fShowInvalidTelMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidCEPMSG(const Value: Boolean);
begin
  fShowInvalidCEPMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidCPFMSG(const Value: Boolean);
begin
  fShowInvalidCPFMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidCNPJMSG(const Value: Boolean);
begin
  fShowInvalidCNPJMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidAddressMSG(const Value: Boolean);
begin
  fShowInvalidAddressMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidCityMSG(const Value: Boolean);
begin
  fShowInvalidCityMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidEmailMSG(const Value: Boolean);
begin
  fShowInvalidEmailMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidProfissaoMSG(const Value: Boolean);
begin
  fShowInvalidProfissaoMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidEscolaridadeMSG(const Value: Boolean);
begin
  fShowInvalidEscolaridadeMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidSectorMSG(const Value: Boolean);
begin
  fShowInvalidSectorMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidStateMSG(const Value: Boolean);
begin
  fShowInvalidStateMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUserNameMSG(const Value: Boolean);
begin
  fShowInvalidUserNameMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidComplementoMSG(const Value: Boolean);
begin
  fShowInvalidComplementoMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidMoneyMSG(const Value: Boolean);
begin
  fShowInvalidMoneyMSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUser01MSG(const Value: Boolean);
begin
  fShowInvalidUser01MSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUser02MSG(const Value: Boolean);
begin
  fShowInvalidUser02MSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUser03MSG(const Value: Boolean);
begin
  fShowInvalidUser03MSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUser04MSG(const Value: Boolean);
begin
  fShowInvalidUser04MSG := Value;
end;

procedure TMaskEditHV.SetShowInvalidUser05MSG(const Value: Boolean);
begin
  fShowInvalidUser05MSG := Value;
end;

procedure TMaskEditHV.SetTitleErrorMSG(const Value: String);
begin
  fTitleErrorMSG := Value;
end;

procedure TMaskEditHV.SetEstado(const Value: string);
begin
  fEstado := Value;
end;

procedure TMaskEditHV.SetShowCurrencyString(const Value: Boolean);
begin
  fShowCurrencyString := Value;
  if not fCheckMoney then Exit;
  if fShowCurrencyString then
    Self.Text := FormatFloat('R$ #,0.00',0)
  else if fCheckMoney then
    Self.Text := FormatFloat('#,0.00',0);
end;

procedure TMaskEditHV.SetEstadoCEPAutoDetect(const Value: Boolean);
begin
  fEstadoCEPAutoDetect := Value;
end;

procedure TMaskEditHV.SetEmptyCheckDate(const Value: Boolean);
begin
  fCheckEmptyDate := Value;
end;

procedure TMaskEditHV.SetEmptyCheckDateTime(const Value: Boolean);
begin
  fCheckEmptyDateTime := Value;
end;

procedure TMaskEditHV.SetEmptyCheckTime(const Value: Boolean);
begin
  fCheckEmptyTime := Value;
end;

procedure TMaskEditHV.SetEmptyCheckCEP(const Value: Boolean);
begin
  fCheckEmptyCEP := Value;
end;

procedure TMaskEditHV.SetEmptyCheckCPF(const Value: Boolean);
begin
  fCheckEmptyCPF := Value;
end;

procedure TMaskEditHV.SetEmptyCheckCNPJ(const Value: Boolean);
begin
  fCheckEmptyCNPJ := Value;
end;

procedure TMaskEditHV.SetEmptyCheckTel(const Value: Boolean);
begin
  fCheckEmptyTel := Value;
end;

procedure TMaskEditHV.SetEmptyCheckAddress(const Value: Boolean);
begin
  fCheckEmptyAddress := Value;
end;

procedure TMaskEditHV.SetEmptyCheckCity(const Value: Boolean);
begin
  fCheckEmptyCity := Value;
end;

procedure TMaskEditHV.SetEmptyCheckEmail(const Value: Boolean);
begin
  fCheckEmptyEmail := Value
end;

procedure TMaskEditHV.SetEmptyCheckProfissao(const Value: Boolean);
begin
  fCheckEmptyProfissao := Value;
end;

procedure TMaskEditHV.SetEmptyCheckEscolaridade(const Value: Boolean);
begin
  fCheckEmptyEscolaridade := Value;
end;

procedure TMaskEditHV.SetEmptyCheckSector(const Value: Boolean);
begin
  fCheckEmptySector := Value;
end;

procedure TMaskEditHV.SetEmptyCheckState(const Value: Boolean);
begin
  fCheckEmptyState := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUserName(const Value: Boolean);
begin
  fCheckEmptyUserName := Value;
end;

procedure TMaskEditHV.SetEmptyCheckComplemento(const Value: Boolean);
begin
  fCheckEmptyComplemento := Value;
end;

procedure TMaskEditHV.SetEmptyCheckMoney(const Value: Boolean);
begin
  fCheckEmptyMoney := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUser01(const Value: Boolean);
begin
  fCheckEmptyUser01 := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUser02(const Value: Boolean);
begin
  fCheckEmptyUser02 := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUser03(const Value: Boolean);
begin
  fCheckEmptyUser03 := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUser04(const Value: Boolean);
begin
  fCheckEmptyUser04 := Value;
end;

procedure TMaskEditHV.SetEmptyCheckUser05(const Value: Boolean);
begin
  fCheckEmptyUser05 := Value;
end;

function TMaskEditHV.CheckIfEmptyDateTime: Boolean;
begin
  Result := (DateTimeFormat) and (fCheckEmptyDateTime) and (EmptyDateTime);
end;

function TMaskEditHV.CheckIfEmptyDate: Boolean;
begin
  Result := (DateFormat)    and (fCheckEmptyDate)      and (EmptyDate);
end;

function TMaskEditHV.CheckIfEmptyTime: Boolean;
begin
  Result := (TimeFormat)    and (fCheckEmptyTime)      and (EmptyTime);
end;

procedure TMaskEditHV.TrimMask;
begin
  if fCheckDateTime then Self.EditMask := '99/99/999999:99;1;_';
  if fCheckTel then
  begin
    if TelFormat1 then Self.EditMask := '(99)9999-9999;1;_'
    else if TelFormat2 then Self.EditMask := '(999)9999-9999;1;_';
  end;
end;

procedure TMaskEditHV.UnTrimMask;
begin
  if fCheckDateTime then Self.EditMask := '99/99/9999 99:99;1;_';
  if fCheckTel then
  begin
    if {TelFormat1} (Self.EditMask = '(99)9999-9999;1;_')   then Self.EditMask := '(99) 9999-9999;1;_'
    else if {TelFormat2} (Self.EditMask = '(999)9999-9999;1;_')  then Self.EditMask := '(999) 9999-9999;1;_';
  end;
end;

function TMaskEditHV.DateFormat: Boolean;
begin
  // Valida formato dd/mm/yy e dd/mm/yyyy
  Result:= (System.Pos('/',Self.Text) = 3) and (System.Pos('/', Copy(Self.Text,6,1)) = 1)
end;

function TMaskEditHV.DateTimeFormat: Boolean;
begin
  // Valida formato dd/mm/yy hh:mm e dd/mm/yyyy hh:mm
  // A validao no est sendo feita para os segundos.
  Result := ((System.Pos('/',Self.Text) = 3) and (System.Pos('/', Copy(Self.Text,6,1)) = 1))
  and (((System.Pos(':', Copy(Self.Text,12,1)) = 1) and (length(Self.Text) = 14))
  or ((System.Pos(':', Copy(Self.Text,14,1)) = 1) and (length(Self.Text) = 16)));
end;

function TMaskEditHV.TimeFormat: Boolean;
begin
  // Valida formato hh:mm
  Result:= (System.Pos(':',Self.Text) = 3) and (length(Self.Text) = 5);
end;

function TMaskEditHV.CPFFormat: Boolean;
begin
  Result := (Self.EditMask = '999.999.999-99;1;_');
end;

function TMaskEditHV.CEPFormat: Boolean;
begin
  Result := (Self.EditMask = '99.999-999;1;_');
end;

function TMaskEditHV.TelFormat1: Boolean;
begin
  Result := (Self.EditMask = '(99) 9999-9999;1;_');
end;

function TMaskEditHV.TelFormat2: Boolean;
begin
  Result := (Self.EditMask = '(999) 9999-9999;1;_');
end;

function TMaskEditHV.CNPJFormat: Boolean;
begin
  Result := (Self.EditMask = '99\.999\.999\/9999\-99;1;_');
end;

{function TMaskEditHV.TelFormat: Boolean;
begin
  Result := (Self.EditMask = '(999) 9999-9999;1;_') or (Self.EditMask = '(99) 9999-9999;1;_');
end;
}
procedure TMaskEditHV.SetTitleOKMSG(const Value: String);
begin
  fTitleOKMSG := Value;
end;

procedure TMaskEditHV.SetTitleWarningMSG(const Value: String);
begin
  fTitleWarningMSG := Value;
end;

procedure TMaskEditHV.SetDateName(const Value: String);
begin
  fDateName := Value;
end;

procedure TMaskEditHV.SetDateTimeName(const Value: String);
begin
  fDateTimeName := Value;
end;

procedure TMaskEditHV.SetTimeName(const Value: String);
begin
  fTimeName := Value;
end;

procedure TMaskEditHV.SetCEPName(const Value: String);
begin
  fCEPName := Value;
end;

procedure TMaskEditHV.SetCPFName(const Value: String);
begin
  fCPFName := Value;
end;

procedure TMaskEditHV.SetCNPJName(const Value: String);
begin
  fCNPJName := Value;
end;

procedure TMaskEditHV.SetTELName(const Value: String);
begin
  fTELName := Value;
end;


procedure TMaskEditHV.SetCityName(const Value: String);
begin
  fCityName := Value;
end;

procedure TMaskEditHV.SetEmailName(const Value: String);
begin
  fEmailName := Value;
end;

procedure TMaskEditHV.SetSectorName(const Value: String);
begin
  fSectorName := Value;
end;

procedure TMaskEditHV.SetStateName(const Value: String);
begin
  fStateName := Value;
end;

procedure TMaskEditHV.SetProfissaoName(const Value: String);
begin
  fProfissaoName := Value;
end;

procedure TMaskEditHV.SetEscolaridadeName(const Value: String);
begin
  fEscolaridadeName := Value;
end;

procedure TMaskEditHV.SetUserName(const Value: String);
begin
  fUserName := Value;
end;

procedure TMaskEditHV.SetAddressName(const Value: String);
begin
  fAddressName := Value;
end;

procedure TMaskEditHV.SetComplementoName(const Value: String);
begin
  fComplementoName := Value;
end;

procedure TMaskEditHV.SetMoneyName(const Value: string);
begin
  fMoneyName := Value;
end;

procedure TMaskEditHV.SetUser01Name(const Value: String);
begin
  fUser01Name := Value;
end;

procedure TMaskEditHV.SetUser02Name(const Value: String);
begin
  fUser02Name := Value;
end;

procedure TMaskEditHV.SetUser03Name(const Value: String);
begin
  fUser03Name := Value;
end;

procedure TMaskEditHV.SetUser04Name(const Value: String);
begin
  fUser04Name := Value;
end;

procedure TMaskEditHV.SetUser05Name(const Value: String);
begin
  fUser05Name := Value;
end;                   


function TMaskEditHV.IsSilentError: Boolean;
function SilentEmptyExists: Boolean;
begin
  TrimMask;
  Result := (System.Pos(' ',Self.Text) > 0);
  UnTrimMask;
end;
var
  fSaveLastBool, fSaveLastBool2: Boolean;
begin
  Result := False;
  bSilentError := True;
  if DateTimeFormat then
  begin
    Result := (EmptyDateTime) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidDateTimeMSG;
      fSaveLastBool2 := fShowInvalidDateMSG;
      fShowInvalidDateTimeMSG := False;
      fShowInvalidDateMSG := False;
      Result := not (Self.IsValidDateAndTime);
      fShowInvalidDateMSG     := fSaveLastBool2;
      fShowInvalidDateTimeMSG := fSaveLastBool;
    end;
    Exit;
  end;

  if DateFormat then
  begin
    Result := (EmptyDate) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidDateTimeMSG;
      fSaveLastBool2 := fShowInvalidDateMSG;
      fShowInvalidDateTimeMSG := False;
      fShowInvalidDateMSG := False;
      Result := not (Self.IsValidDate);
      fShowInvalidDateMSG     := fSaveLastBool2;
      fShowInvalidDateTimeMSG := fSaveLastBool;
    end;
    //Self.DoExit;
    Exit;
  end;

  if TimeFormat then
  begin
    Result := (EmptyTime) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidTimeMSG;
      fShowInvalidTimeMSG := False;
      Result := not (Self.IsValidTime);
      fShowInvalidTimeMSG := fSaveLastBool;
    end;
    Exit;
  end;

  if CPFFormat then
  begin
    Result := (EmptyCPF) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidCPFMSG;
      fShowInvalidCPFMSG := False;
      Result := not (Self.IsValidCPF);
      fShowInvalidCPFMSG := fSaveLastBool;
    end;
    Exit;
  end;

  if CNPJFormat then
  begin
    Result := (EmptyCNPJ) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidCNPJMSG;
      fShowInvalidCNPJMSG := False;
      Result := not (Self.IsValidCNPJ);
      fShowInvalidCNPJMSG := fSaveLastBool;
    end;
    Exit;
  end;


  if CEPFormat then
  begin
    Result := (EmptyCEP) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidCEPMSG;
      fShowInvalidCEPMSG := False;
      Result := not (Self.IsValidCEP);
      fShowInvalidCEPMSG := fSaveLastBool;
    end;
    Exit;
  end;

  if (TelFormat1 or TelFormat2) then
  begin
    Result := (EmptyTel) or (SilentEmptyExists);
    if not Result then
    begin
      fSaveLastBool := fShowInvalidTelMSG;
      fShowInvalidTelMSG := False;
      //Result := not (Self.IsValidTel);
      fShowInvalidTelMSG := fSaveLastBool;
    end;
    Exit;
  end;
end;

procedure TMaskEditHV.SetCannotContainEmptyCaracter(const Value: String);
begin
  fCannotContainEmptyCaracter := Value;
end;

procedure TMaskEditHV.SetVersion;
begin
  fVersion := cVersion;
end;

procedure TMaskEditHV.SetListState(const Value: Boolean);
begin
  fShowListState := Value;
end;

procedure TMaskEditHV.SetListCity(const Value: Boolean);
begin
  fShowListCity := Value;
end;

procedure TMaskEditHV.SetListProfissao(const Value: Boolean);
begin
  fShowListProfissao := Value;
end;

procedure TMaskEditHV.SetListEscolaridade(const Value: Boolean);
begin
 fShowListEscolaridade := Value;
end;


procedure TMaskEditHV.GetList;
begin
  combo := TComboBox.Create(Owner);
  with combo do
  begin
    Parent :=  Self.Parent;
    Left   := TComboBox(Self).Left;
    Top    := TComboBox(Self).Top;
    Width  := TComboBox(Self).Width + 10;
    Style  := csDropDownList;

    if (fCheckState)      and (fShowListState)  then Self.LoadTempXML('ESTADOS','CD_ESTADO')
    else if (fCheckCity)  and (fShowListCity)   then Self.LoadTempXML('CIDADES','DS_CIDADE')
    else if (fCheckProfissao) and (fShowListProfissao) then Self.LoadTempXML('PROFISSAO','DS_PROFISSAO')
    else if (fCheckEscolaridade) and (fShowListEscolaridade) then Self.LoadTempXML('ESCOLARIDADE','DS_ESCOLARIDADE');

    OnChange := MyChange;
    OnKeyPress := MyKeyPress;
    if (Self.Text <> '') then
    begin
      combo.ItemIndex := combo.Items.IndexOf(Self.Text);
      if (combo.ItemIndex = -1) then combo.ItemIndex := 0;
    end
    else
    begin
      combo.ItemIndex := 0;
      Self.Text := combo.Items.Strings[0];
    end;

    combo.SetFocus;
  end;
end;
                                  
procedure TMaskEditHV.MyChange(Sender: TObject);
begin
  if Assigned(combo) then
    Self.Text := combo.Items.Strings[combo.itemIndex];
end;

procedure TMaskEditHV.MyKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then
  begin
    Self.Text := combo.Items.Strings[combo.itemIndex];
    combo.Visible := False;
    Self.SetFocus;
    keybd_event(VK_TAB, 0, 0, 0); //se usasse o evento self.keypress, ele duplicava...
  end;
end;

procedure TMaskEditHV.DelFile(vMasc: String);
var
  Dir : TSearchRec;
  Erro: Integer;
Begin
  Erro := SysUtils.FindFirst(vMasc,faArchive,Dir);
  while (Erro = 0) do
  begin
    SysUtils.DeleteFile(SysUtils.ExtractFilePAth(vMasc)+ Dir.Name);
    Erro := SysUtils.FindNext(Dir);
  end;
  SysUtils.FindClose(Dir);
end;

function TMaskEditHV.extractResFromPas(binresname, path: string): boolean;
var
  ResSize, HG, HI, SizeWritten, hFileWrite: Cardinal;
begin
  result := false;
  HI := FindResource(hInstance, @binresname[1], RT_RCDATA);
  if HI <> 0 then
  begin
    HG := LoadResource(hInstance, HI);
    if HG <> 0 then
    begin
      ResSize := SizeOfResource(hInstance, HI);
      hFileWrite := CreateFile(@path[1], GENERIC_READ or GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, nil,
      CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0);
    if hFileWrite <> INVALID_HANDLE_VALUE then
      try
        result := (WriteFile(hFileWrite, LockResource(HG)^, ResSize, SizeWritten, nil) and (SizeWritten = ResSize));
      finally
        CloseHandle(hFileWrite);
      end;
    end;
  end;
end;

function TMaskEditHV.GetCurrentState: string;
var
  i: integer;
begin
  Result := '';
  for I := 0 to pred(Owner.ComponentCount) do
  begin
    if (Owner.Components[I] is TMaskeditHV) then
    begin
      if (TMaskeditHV(Owner.Components[I]).CheckState) then
      begin
        Result := TMaskeditHV(Owner.Components[I]).Estado;
        if (TMaskeditHV(Owner.Components[I]).Text = '') then (TMaskeditHV(Owner.Components[I]).Text := fEstado);
        Break;
      end;
    end;
  end;
end;


procedure TMaskEditHV.LoadTempXML(const tempXML, tempIndex: string);
var
  tempClientDataSet: TClientDataSet;
  tempXMLFile, sCurrentState: string;
begin
  try
    tempClientDataSet := TClientDataSet.Create(Self);
    tempXMLFile       := tempXML + '.XML';

    extractResFromPas(tempXML,  '.\' + tempXMLFile );
    tempClientDataSet.LoadFromFile(ExtractFilePath(Application.ExeName) +  tempXMLFile);
    tempClientDataSet.Open;
    tempClientDataSet.IndexFieldNames := tempIndex;

    if (fCheckCity) and (fShowListCity) then
    begin
      sCurrentState := GetCurrentState;
      if (sCurrentState <> '') then
      begin
        tempClientDataSet.Filter := 'CD_ESTADO = ' + QuotedStr(sCurrentState);
        tempClientDataSet.Filtered := True;
      end;
    end;

    try
      tempClientDataSet.DisableControls;
      tempClientDataSet.First;
      while not tempClientDataSet.Eof do
      begin
        Combo.Items.Add(tempClientDataSet.fieldByName(tempIndex).AsString);
        tempClientDataSet.Next;
      end;
    finally
      tempClientDataSet.EnableControls;
    end;
  finally
    FreeAndNil(tempClientDataSet);
    Self.DelFile(ExtractFilePath(Application.ExeName) + tempXMLFile);
  end;
end;

procedure TMaskEditHV.GetMonthCalendar;
begin
  MonthCalendar := TMonthCalendar.Create(Self);
  with MonthCalendar do
  begin
    Parent     := Self.Parent;
    Left       := TMonthCalendar(Self).Left + 90;
    Top        := TMonthCalendar(Self).Top;
    Width      := TMonthCalendar(Self).Width;
    OnDblClick := MonthCalendarDblClick;
   // OnKeyPress := MonthCalendarKeyPress;
   // OnClick := MonthCalendarClick;
  end;
end;


procedure TMaskEditHV.MonthCalendarDblClick(Sender: TObject);
begin
  inherited;
  if Assigned(MonthCalendar) and (MonthCalendar.Visible) then
  begin
    Self.Text := DateToStr(MonthCalendar.Date);
    MonthCalendar.Visible := False;
    Self.SetFocus;
  end;
end;

{procedure TMaskEditHV.Teste;
begin
  ShowMessage('ok');
end;
}
procedure TMaskEditHV.MonthCalendarKeyPress(Sender: TObject;
  var Key: Char);
begin
  inherited;
  if (key = #13) then
  begin
    Self.Text := DateToStr(MonthCalendar.Date);
    MonthCalendar.Visible := False;
    Self.SetFocus;
  end;
end;


procedure Register;
begin
  RegisterComponents('Additional', [TMaskEditHV]);
end;

end.

