unit UMenu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Buttons, ImgList,UThreadData;

type
  TFrmMenu = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox2: TGroupBox;
    lvResultThread03: TListView;
    GroupBox1: TGroupBox;
    btnExecuteThread03: TBitBtn;
    btnTerminateThread03: TBitBtn;
    GroupBox3: TGroupBox;
    cbxPriorityThread03: TComboBox;
    GroupBox4: TGroupBox;
    lvResultThread02: TListView;
    GroupBox5: TGroupBox;
    btnExecuteThread02: TBitBtn;
    btnTerminateThread02: TBitBtn;
    GroupBox6: TGroupBox;
    cbxPriorityThread02: TComboBox;
    GroupBox7: TGroupBox;
    lvResultThread01: TListView;
    GroupBox8: TGroupBox;
    btnExecuteThread01: TBitBtn;
    btnTerminateThread01: TBitBtn;
    GroupBox9: TGroupBox;
    cbxPriorityThread01: TComboBox;
    ImageList1: TImageList;
    procedure FormShow(Sender: TObject);
    procedure btnExecuteThread01Click(Sender: TObject);
    procedure btnTerminateThread01Click(Sender: TObject);
    procedure cbxPriorityThread01Click(Sender: TObject);

  private
    { Private declarations }
    FThreadData01:TThreadData;
    FThreadData02:TThreadData;
    FThreadData03:TThreadData;
  public
    { Public declarations }
    procedure LoadThreadPriorityList(pCbx:TComboBox);
    function CreateThreadData(pAutoStart:boolean; pPriority: TThreadPriority; pLv:TListView; pImageIndex:byte):TThreadData;
    procedure ThreadTerminated(Sender:TObject);
  end;

var
  FrmMenu: TFrmMenu;

implementation

{$R *.DFM}

function TFrmMenu.CreateThreadData(pAutoStart:boolean; pPriority: TThreadPriority; pLv:TListView; pImageIndex:byte):TThreadData;
begin
  {$Region 'Criar uma instncia da classe TThreadData'}
  result:=TThreadData.Create(pAutoStart);
  result.Priority:=pPriority;
  result.ListView:=pLv;
  result.ImageIndex:=pImageIndex;
  result.OnTerminate:=ThreadTerminated;
  result.FreeOnTerminate:=true;
  {$endregion}
end;

procedure TFrmMenu.ThreadTerminated(Sender: TObject);
begin
  {$region 'Finalizar a Thread explicitamente'}
  if (Sender as TThreadData) = FThreadData01 then begin
     btnExecuteThread01.Caption:='Executar';
     FThreadData01:=nil;
  end;

  if (Sender as TThreadData) = FThreadData02 then begin
     btnExecuteThread02.Caption:='Executar';
     FThreadData02:=nil;
  end;

  if (Sender as TThreadData) = FThreadData03 then begin
     btnExecuteThread03.Caption:='Executar';
     FThreadData03:=nil;
  end;
  {$endregion}
end;

procedure TFrmMenu.btnExecuteThread01Click(Sender: TObject);
begin
  {$region 'Manipular o comportamento da Thread'}
  if Sender=btnExecuteThread01 then begin
    if btnExecuteThread01.Caption='Executar' then begin
       if not Assigned(FThreadData01) then
         FThreadData01:=CreateThreadData(false,tpLower,lvResultThread01,0)
       else
         FThreadData01.Suspended:=false;
       btnExecuteThread01.Caption:='Parar';
    end
    else begin
      FThreadData01.Suspended:=true;
      btnExecuteThread01.Caption:='Executar';
    end
  end;

  if Sender=btnExecuteThread02 then begin
    if btnExecuteThread02.Caption='Executar' then begin
       if not Assigned(FThreadData02) then
         FThreadData02:=CreateThreadData(false,tpHighest,lvResultThread02,1)
       else
         FThreadData02.Suspended:=false;
       btnExecuteThread02.Caption:='Parar';
    end
    else begin
      FThreadData02.Suspended:=true;
      btnExecuteThread02.Caption:='Executar';
    end
  end;

  if Sender=btnExecuteThread03 then begin
    if btnExecuteThread03.Caption='Executar' then begin
       if not Assigned(FThreadData03) then
         FThreadData03:=CreateThreadData(false,tpNormal,lvResultThread03,2)
       else
         FThreadData03.Suspended:=false;
       btnExecuteThread03.Caption:='Parar';
    end
    else begin
      FThreadData03.Suspended:=true;
      btnExecuteThread03.Caption:='Executar';
    end
  end;
  {$endregion}
end;

procedure TFrmMenu.btnTerminateThread01Click(Sender: TObject);
begin
   {$region 'Finalizar a Thread explicitamente'}
   if Sender=btnTerminateThread01 then begin
     if Assigned(FThreadData01) then begin
        FThreadData01.Terminate;
        btnExecuteThread01.Caption:='Executar';
        lvResultThread01.Items.Clear;
     end;
     exit;
  end;

  if Sender=btnTerminateThread02 then begin
     if Assigned(FThreadData02) then begin
        FThreadData02.Terminate;
        btnExecuteThread02.Caption:='Executar';
        lvResultThread02.Items.Clear;
     end;
     exit;
  end;

  if Sender=btnTerminateThread03 then begin
     if Assigned(FThreadData03) then begin
        FThreadData03.Terminate;
        btnExecuteThread03.Caption:='Executar';
        lvResultThread03.Items.Clear;
     end;
     exit;
  end;
  {$endregion}
end;

procedure TFrmMenu.LoadThreadPriorityList(pCbx: TComboBox);
begin
  {$region 'Carregar todos os tipos enumerados'}
  pCbx.Items.Append('tpIdle');
  pCbx.Items.Append('tpLowest');
  pCbx.Items.Append('tpLower');
  pCbx.Items.Append('tpNormal');
  pCbx.Items.Append('tpHigher');
  pCbx.Items.Append('tpHigher');
  pCbx.Items.Append('tpHighest');
  pCbx.Items.Append('tpTimeCritical');
  {$endregion}
end;

procedure TFrmMenu.cbxPriorityThread01Click(Sender: TObject);
begin
  {$region 'Mudar a prioridade da Thread'}
  if Sender =cbxPriorityThread01 then begin
     if Assigned(FThreadData01) then
        FThreadData01.Priority:= TThreadPriority(cbxPriorityThread01.ItemIndex);
     exit;
  end;

  if Sender =cbxPriorityThread02 then begin
     if Assigned(FThreadData02) then
        FThreadData02.Priority:= TThreadPriority(cbxPriorityThread02.ItemIndex);
     exit;
  end;

  if Sender =cbxPriorityThread03 then begin
     if Assigned(FThreadData03) then
        FThreadData03.Priority:= TThreadPriority(cbxPriorityThread03.ItemIndex);
     exit;
  end
  {$endregion}
end;

procedure TFrmMenu.FormShow(Sender: TObject);
begin
  {$region 'Carregar a lista de prioridade dos combobox'}
  LoadThreadPriorityList(cbxPriorityThread01);
  LoadThreadPriorityList(cbxPriorityThread02);
  LoadThreadPriorityList(cbxPriorityThread03);
  {$endregion}
end;
end.
